<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing DocmanFolder
//
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/docman/lib/html/DocmanAdminTemplate.php');
$theme = new DocmanAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$folder_id = (isset($_REQUEST['id'])) ? $_REQUEST['id'] : (isset($folder_id) ? $folder_id : '');
$DocmanFolder = DocmanFolderPeer::retrieveByPk($folder_id);
if (!is_object($DocmanFolder) || !$DocmanFolder->userCanUpdate()) {
	throw new PermissionDeniedException();
}
if ($DocmanFolder->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}
$obj = $DocmanFolder;

$params = array(
		'project' => $Project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('DocmanFolder.EditPageTitle')
		);

$folder_name = ( (isset($_POST) && isset($_POST['folder_name'])) ? htmlspecialchars($_POST['folder_name']) : $obj->getFolderName() );
$is_public = ( (isset($_POST) && isset($_POST['is_public'])) ? htmlspecialchars($_POST['is_public']) : $obj->getIsPublic() );
$parent_folder_id = $DocmanFolder->getParentFolderId();

include ('forms/DocmanFolderEdit-tpl.php');

?>
