<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'news' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.news.lib.map
 */
class NewsMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.news.lib.map.NewsMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("news");
		$tMap->setPhpName("News");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("news_news_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("NEWS_ID", "NewsId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("PROJECT_ID", "ProjectId", "int", CreoleTypes::INTEGER, "project" , "PROJECT_ID", true);
		$tMap->addForeignKey("SUBMITTED_BY", "SubmittedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("IS_APPROVED", "IsApproved", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("POST_DATE", "PostDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("SUMMARY", "Summary", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("DETAILS", "Details", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
