<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: ScmUserStatsPeer.php 3226 2008-08-06 17:58:08Z bigdisk $
 * @author Tim Perdue tim@gforge.org
 * @date 2006-01-03
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
// The parent class
require_once 'plugins/scm/lib/om/BaseScmUserStatsPeer.php';

// The object class
include_once 'plugins/scm/lib/ScmUserStats.php';

require_once('core/User.php');

/** 
 * The skeleton for this class was autogenerated by Propel on:
 *
 * [Wed Jan  4 05:51:25 2006]
 *
 *  You should add additional methods to this class to meet the
 *  application requirements.  This class will only be generated as
 *  long as it does not already exist in the output directory.
 *
 * @package plugins.scm.lib 
 */
class ScmUserStatsPeer extends BaseScmUserStatsPeer {
	private static $_pkCache = array();

	/**
	 * Retrieve a single object by pkey or NULL if not found.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key
	 * @param	bool $useCache	Whether to use caching. This will increase performance if the same object
	 *							is accessed several times
	 * @param	Connection $con	The connection to use
	 * @return	ScmUserStats
	 */
	public static function retrieveByPk($pk, $useCache = true, $con = null) {
		if ($useCache && array_key_exists($pk, ScmUserStatsPeer::$_pkCache)) {
			return ScmUserStatsPeer::$_pkCache[$pk];
		}
		
		$object = parent::retrieveByPk($pk, $con);
		if ($useCache) {
			ScmUserStatsPeer::$_pkCache[$pk] = $object;
		}
		return $object;
	}
	
	/**
	 * Removes an object from the cache. This is usually done after saving.
	 * This method was added by propel_customizer.php.
	 *
	 * @param	mixed $pk	The primary key of the object to remove
	 */
	public static function invalidate($pk) {
		if (array_key_exists($pk, ScmUserStatsPeer::$_pkCache)) {
			unset(ScmUserStatsPeer::$_pkCache[$pk]);
		}
	}
	
	public static function retrieveUserStats($project_id) {
		
		$project_id = Validator::sanitizeInt($project_id);
				
		$sql = 'SELECT u.*, total_stats.total_checkouts, total_stats.total_commits, total_stats.total_adds
				FROM '.UserPeer::TABLE_NAME.' AS u, 
				 (SELECT user_id, SUM(checkouts) AS total_checkouts, 
				  SUM(commits) AS total_commits, SUM(adds) AS total_adds 
				  FROM scm_user_stats WHERE project_id='.$project_id.'
				  GROUP BY user_id) AS total_stats
				WHERE total_stats.user_id=u.user_id
				';
		
		$con = Propel::getConnection(self::DATABASE_NAME);
		$stmt = $con->createStatement();
		$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM);

		$res = array();
		while ($rs->next()) {
			$user_data = array();
			
			$user = new User();
			$user->hydrate($rs);
			$user_data['user'] = $user;

			$offset = (UserPeer::$numColumns - UserPeer::$numLazyLoadColumns);
			$user_data['checkouts'] = $rs->getInt($offset + 1);
			$user_data['commits'] = $rs->getInt($offset + 2);
			$user_data['adds'] = $rs->getInt($offset + 3);
			
			$res[] = $user_data;
		}
		
		return $res;
	}

}
?>