<?php
/**
 * Copyright (c) 2006 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * ## GFORGE GROUP LICENSE TERMS ##
 */
//
// This code lists ScmCommit
//
require_once('plugins/scm/lib/ScmCommitPeer.php');
require_once('plugins/scm/lib/ScmCommit.php');
require_once('html/Paginator.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/scm/lib/html/ScmTemplate.php');
$Project = GFUrl::getUrl()->getProject();
$theme->header($params);

$columns = array(
		'scm_commit_id' => $Lang->getText('ScmCommit.Id'),
		'commit_date' => $Lang->getText('ScmCommit.DateTitle'),
		'message_log'=> $Lang->getText('ScmCommit.CommitLogTitle'),
		'unix_name'=> $Lang->getText('ScmCommit.CommittedByTitle')
		);

$users = array();
$users[0] = 'All';

//get a list of all project users
foreach ($Project->getMembers() as $member) {
	$users[$member->getUserId()] = $member->getFullName();
}
//get selected filters -if any-
$user_id=((isset($_REQUEST['user_id'])) ? Validator::sanitizeInt($_REQUEST['user_id']) : 0 );
$begin=((isset($_REQUEST['start_date'])) ? $_REQUEST['start_date'] : 0 );
$end=((isset($_REQUEST['end_date'])) ? $_REQUEST['end_date'] : 0 );

if ($begin=='0') {
	$begin = (time()-(30*86400));
} else {
	$begin = strtotime($begin);
}
if ($end=='0') {
	$end = time();
} else {
	$end=strtotime($end)+86399;
}
if ($begin > $end) {
	$endtmp=$end;
	$end=$begin;
	$begin=$endtmp;
}
$sqlFilter = '';

if($user_id > 0){
	$sqlFilter = ' AND "user".user_id = ' . $user_id ;
}

$total=0;
$project_id = $Project->getProjectId();
$default_sort_by='commit_date';
$sqltmp='SELECT 
						scm_commit.*, 
						"user".unix_name, 
						"user".firstname, 
						"user".lastname 
				FROM 
						scm_commit, 
						"user"  
				WHERE 
						project_id=' . $project_id . '
				AND 
					"user".user_id=scm_commit.user_id
				AND
					scm_commit.commit_date >= \'' . date('Y/m/d',$begin) . '\'
				AND
					scm_commit.commit_date <= \'' . date('Y/m/d h:m',$end) . '\'					
				' 
				. $sqlFilter;
//echo $sqltmp; exit;
$sqlCount = "SELECT COUNT(*) AS count FROM ($sqltmp) foo";

$con=Propel::getConnection(FrsPackagePeer::DATABASE_NAME);
$stmtCount = $con->createStatement();
$rsCount = $stmtCount->executeQuery($sqlCount);

if ($rsCount->next()) {
	$total = $rsCount->getInt('count');
}

$paginator = new Paginator('br_pkgrls', -1, $total, $default_sort_by, $columns);
$sqlAux = $paginator->getSQL();

//get the items to put into paginator
$sql="$sqltmp $sqlAux";

$stmt = $con->createStatement();
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);

$sort = $paginator->getSortingOptions();
$sort_by = $sort['sort_by'];
$sort_order = $sort['order'];

$theader = $paginator->getSortableTableHeaders($theme);

?>
<script language="javascript" type="text/javascript" src="/datetimepicker.js"></script>
<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post">
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<tr>
<tr>
	<td><strong><?php echo $Lang->getText('TrackerReporting.FilterByUser') ?></strong></td>
	<td><?php echo HTMLWidget::selectBoxFromAssoc($users,'user_id',$user_id, false, false) ?></td>
	<td><input id="startdate" name="start_date" value="<?php echo date('M d Y',$begin); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('startdate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td><input id="enddate" name="end_date" value="<?php echo date('M d Y',$end); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('enddate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td valign="middle" rowspan="2"><?php echo HTMLWidget::button("submit","" .   $Lang->getText('Common.Submit')  . " ","submit","","")?></td>
</tr>
</tr>
</table>
</from>
<?php 

echo $theme->tableTop($theader);

if ($total < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('ScmCommit.NoneFound').'</span>');
} else {
	$scmplugin = $Project->getExclusiveTypePlugin('scm');
	if (is_null($scmplugin)){
		throw new PermissionDeniedException();
	}
	
	while($rs->next()){
			//get commit url
			$address = GFUrl::getURL()->projectURL($Project, 'ScmCommitDetail', 
																				 		 $scmplugin->getName(), '', 
																				 		 array('scm_commit_id'=> $rs->getInt('scm_commit_id')));
			
			$trow = array();
			$trow[]='<a href="'. $address . '">' . $rs->getInt('scm_commit_id') . '</a>';
			$trow[]=$rs->getDate('commit_date') . ' ' . $rs->getTime('commit_date');
			$trow[]=$rs->getString('message_log');
			$trow[]='<a href="/gf/user/'.$rs->getString('unix_name').'/">'.$rs->getString('firstname'). ' '. $rs->getString('lastname').'</a>';
			echo $theme->tableRow($trow);
	}
	
}

echo $theme->listPaginatorRow($paginator);
echo $theme->tableBottom();

$theme->footer($params);

?>
