<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new ScmModule and saves it to the 
// database
//
require_once('plugins/scm/lib/ScmModule.php');
require_once('plugins/scm/lib/ScmModulePeer.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

$Lang = Language::getSessLang();
$project = GFUrl::getUrl()->getProject();

if (isset($_POST['sure'])) {

	$stmt = Propel::getConnection()->prepareStatement('SELECT * FROM code_search_module WHERE code_search_module_id=?');
	$stmt->setInt(1, $_POST['id']);
	$rs = $stmt->executeQuery();

	if (!$rs->next() || $rs->getInt('project_id') != $project->getProjectId() || !$project->getPermission()->isAdmin()) {
		throw new PermissionDeniedException();
	}

	$stmt = Propel::getConnection()->prepareStatement('DELETE FROM code_search_module WHERE code_search_module_id=?');
	$stmt->setInt(1, $_POST['id']);
	$stmt->executeQuery();

	GFUrl::redirect($url->currentBaseURL('CodeSearchModuleBrowse'), array('feedback' => $Lang->getText('CodeSearchModule.DeleteFeedback', array($CODE_SEARCH_MODULE_NAME))));
} else {
	GFUrl::redirect($url->currentBaseURL('CodeSearchModuleBrowse'), array('feedback' => $Lang->getText('ScmModuleDeleteForm.DidntConfirm')));
}

?>
