<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. P�ez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


// this file contains common search functions for site and project

	/**
	 * returns the search results for the given input
	 *
	 * @param array $params
	 * @return resultset
	 */
	function getSearchResults($params) {
		$searcher = new GFSearch($params);
		return searchSnippets($searcher);
	}

	/**
	 *	take a search object and handle the search internally.
	 *	@param	GFSearch
	 *	@return string
	 */
	function searchSnippets(GFSearch $search) {
		if (GFConf::get('system.dbtype') == 'postgres') {		
			$con = Propel::getConnection(UserPeer::DATABASE_NAME);
			$words = $search->getWordsForQuery();

			if(empty($words)){
				return false;
			}
			if(!ini_get('magic_quotes_gpc')){
				$words = addslashes($words);
			}

			if ($words=="*" || $words=="") {
				$sql =  "SELECT	headline(snippet.snippet_name, q) as snippet_name,
										headline(snippet.snippet_description, q) as snippet_description, 
										snippet.snippet_id 
							FROM 	snippet, snippet_idx, 
									to_tsquery('$words') AS q 
							WHERE snippet.snippet_id = snippet_idx.snippet_id;";
			} else {
				$sql = " SELECT	headline(snippet.snippet_name, q) as snippet_name,
										headline(snippet.snippet_description, q) as snippet_description, 
										snippet.snippet_id
							FROM 		snippet, 
										snippet_idx, 
										to_tsquery('$words') AS q 
							WHERE 	(snippet.snippet_id = snippet_idx.snippet_id 
							  AND 	(snippet_idx.vectors @@ q))
							ORDER BY rank(snippet_idx.vectors, q) DESC";
			}
			
			$stmt = $con->createStatement();
			$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_ASSOC);
			if ($rs->getRecordCount()>0) {
				$ret = '';
				$template = $search->getTemplate();
				$project = ProjectPeer::retrieveByPk($search->getProjectId());
				$ret = $template->tableTop(array(Language::getSessText('Snippet.NameName'),Language::getSessText('Snippet.DescriptionName')));
				$i = 0;
				while ($rs->next()) {
					$trow = array();
					$snippet_id = $rs->getInt('snippet_id');
					$c = new Criteria();
					$c->add(SnippetPeer::SNIPPET_ID,$snippet_id);
					$snippet = SnippetPeer::doSelectOne($c);
					$trow[] = '<a href="'. GFUrl::getUrl()->baseURL('SnippetBrowse','snippet','',array('id'=>$snippet->getSnippetID())) . '">'.$rs->getString('snippet_name').'</a>';
					$trow[] = $rs->getString('snippet_description');
					$ret .= $template->tableRow($trow);
				}
				$ret .= $template->tableBottom();
				return $ret;
			} else {
				// cero results for search
				return false;
			}
		} elseif (GFConf::get('system.dbtype') == 'mysql') {
			
		} elseif (GFConf::get('system.dbtype') == 'oracle') {
			
		}
	}