<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerItem.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerItemPeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/tracker/lib/TrackerItemMessagePeer.php';

/**
 * Base class that represents a row from the 'tracker_item_message' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerItemMessage class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerItemMessage extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerItemMessagePeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_item_message_id field.
	 * @var int	  
	 */
	protected $tracker_item_message_id;	

	/**
	 * The value for the tracker_item_id field.
	 * @var int	  
	 */
	protected $tracker_item_id;	

	/**
	 * The value for the submitted_by field.
	 * @var int	  
	 */
	protected $submitted_by;	

	/**
	 * The value for the adddate field.
	 * @var int	  
	 */
	protected $adddate = -1;	

	/**
	 * The value for the body field.
	 * @var string	  
	 */
	protected $body;	
  
	/**
	 * Get the TrackerItemMessageId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerItemMessageId()
	{
		return $this->tracker_item_message_id;
	}


	/**
	 * Set the value of `tracker_item_message_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setTrackerItemMessageId($v)
	{
		if ($this->tracker_item_message_id !== $v) {
			$this->tracker_item_message_id = $v;
			$this->modifiedColumns[] = TrackerItemMessagePeer::TRACKER_ITEM_MESSAGE_ID;
		}
				
	}

  
	/**
	 * Get the TrackerItemId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerItemId()
	{
		return $this->tracker_item_id;
	}


	/**
	 * Set the value of `tracker_item_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerItemId($v)
	{
		if ($this->tracker_item_id !== $v) {
			$this->tracker_item_id = $v;
			$this->modifiedColumns[] = TrackerItemMessagePeer::TRACKER_ITEM_ID;
		}
			
		if ($this->aTrackerItem !== null && $this->aTrackerItem->getTrackerItemId() !== $v) {
			$this->aTrackerItem = null;
		}
			
	}

  
	/**
	 * Get the SubmittedBy column value.
	 *  
	 * @return int	  
	 */
	public function getSubmittedBy()
	{
		return $this->submitted_by;
	}


	/**
	 * Set the value of `submitted_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setSubmittedBy($v)
	{
		if ($this->submitted_by !== $v) {
			$this->submitted_by = $v;
			$this->modifiedColumns[] = TrackerItemMessagePeer::SUBMITTED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}


	/**
	 * Get the [optionally formatted] `adddate` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getAdddate($format = 'Y-m-d H:i:s')
	{
		if ($this->adddate === null || $this->adddate === '') {
			return null;
		} elseif (!is_int($this->adddate)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->adddate);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of adddate as date/time value: " . var_export($this->adddate, true));
			}
		} else {
			$ts = $this->adddate;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `adddate` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setAdddate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for adddate from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->adddate !== $ts || $ts === -1) {
			$this->adddate = $ts;
			$this->modifiedColumns[] = TrackerItemMessagePeer::ADDDATE;
		}
		
	}

  
	/**
	 * Get the Body column value.
	 *  
	 * @return string	  
	 */
	public function getBody()
	{
		return $this->body;
	}


	/**
	 * Set the value of `body` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setBody($v)
	{
		if ($this->body !== $v) {
			$this->body = $v;
			$this->modifiedColumns[] = TrackerItemMessagePeer::BODY;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_item_message_id = $rs->getInt($startcol + 0);					
			$this->tracker_item_id = $rs->getInt($startcol + 1);					
			$this->submitted_by = $rs->getInt($startcol + 2);					
			$this->adddate = $rs->getTimestamp($startcol + 3, null);
			$this->body = $rs->getString($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerItemMessage object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerItemMessagePeer::DATABASE_NAME);
		$criteria->add(TrackerItemMessagePeer::TRACKER_ITEM_MESSAGE_ID, $this->tracker_item_message_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerItemMessagePeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerItemMessagePeer::TRACKER_ITEM_MESSAGE_ID)) $criteria->add(TrackerItemMessagePeer::TRACKER_ITEM_MESSAGE_ID, $this->tracker_item_message_id);
		if ($this->isColumnModified(TrackerItemMessagePeer::TRACKER_ITEM_ID)) $criteria->add(TrackerItemMessagePeer::TRACKER_ITEM_ID, $this->tracker_item_id);
		if ($this->isColumnModified(TrackerItemMessagePeer::SUBMITTED_BY)) $criteria->add(TrackerItemMessagePeer::SUBMITTED_BY, $this->submitted_by);
		if ($this->isColumnModified(TrackerItemMessagePeer::ADDDATE)) $criteria->add(TrackerItemMessagePeer::ADDDATE, $this->adddate);
		if ($this->isColumnModified(TrackerItemMessagePeer::BODY)) $criteria->add(TrackerItemMessagePeer::BODY, $this->body);
		return $criteria;			
	}
	
	

	/**
	 * @var TrackerItem	  
	 */
	protected $aTrackerItem;

	/**
	 * Declares an association between this object and a TrackerItem object
	 *
	 * @param TrackerItem $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItem($v)
	{
			
		if ($v === null) {
			$this->setTrackerItemId(NULL);
		} else {
			$this->setTrackerItemId($v->getTrackerItemId());
		}
   
		$this->aTrackerItem = $v;
	}


	/**
	 * Get the associated TrackerItem object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerItem The associated TrackerItem object.
	 * @throws PropelException
	 */
	public function getTrackerItem($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';

		if ($this->aTrackerItem === null && ($this->tracker_item_id !== null)) {
	
			$this->aTrackerItem = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
			   $obj->addTrackerItemMessages($this);
			 */
		}
		return $this->aTrackerItem;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItemKey($key)
	{

		$this->setTrackerItemId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setSubmittedBy(NULL);
		} else {
			$this->setSubmittedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->submitted_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->submitted_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->submitted_by, $con);
			   $obj->addTrackerItemMessages($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setSubmittedBy( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_item_message_id", "tracker_item_id", "submitted_by", "adddate", "body", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerItemMessagePeer::TRACKER_ITEM_MESSAGE_ID:
				return $this->getTrackerItemMessageId();
				break;
		  
			case TrackerItemMessagePeer::TRACKER_ITEM_ID:
				return $this->getTrackerItemId();
				break;
		  
			case TrackerItemMessagePeer::SUBMITTED_BY:
				return $this->getSubmittedBy();
				break;
		  
			case TrackerItemMessagePeer::ADDDATE:
				return $this->getAdddate();
				break;
		  
			case TrackerItemMessagePeer::BODY:
				return $this->getBody();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerItemMessageId();
				break;
  
			case 1:
				return $this->getTrackerItemId();
				break;
  
			case 2:
				return $this->getSubmittedBy();
				break;
  
			case 3:
				return $this->getAdddate();
				break;
  
			case 4:
				return $this->getBody();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerItemMessagePeer::TRACKER_ITEM_MESSAGE_ID, $arr)) $this->setTrackerItemMessageId($arr[TrackerItemMessagePeer::TRACKER_ITEM_MESSAGE_ID]);
  
		if (array_key_exists(TrackerItemMessagePeer::TRACKER_ITEM_ID, $arr)) $this->setTrackerItemId($arr[TrackerItemMessagePeer::TRACKER_ITEM_ID]);
  
		if (array_key_exists(TrackerItemMessagePeer::SUBMITTED_BY, $arr)) $this->setSubmittedBy($arr[TrackerItemMessagePeer::SUBMITTED_BY]);
  
		if (array_key_exists(TrackerItemMessagePeer::ADDDATE, $arr)) $this->setAdddate($arr[TrackerItemMessagePeer::ADDDATE]);
  
		if (array_key_exists(TrackerItemMessagePeer::BODY, $arr)) $this->setBody($arr[TrackerItemMessagePeer::BODY]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerItemMessagePeer::TRACKER_ITEM_MESSAGE_ID:
				$this->setTrackerItemMessageId($value);
				break;
	  
			case TrackerItemMessagePeer::TRACKER_ITEM_ID:
				$this->setTrackerItemId($value);
				break;
	  
			case TrackerItemMessagePeer::SUBMITTED_BY:
				$this->setSubmittedBy($value);
				break;
	  
			case TrackerItemMessagePeer::ADDDATE:
				$this->setAdddate($value);
				break;
	  
			case TrackerItemMessagePeer::BODY:
				$this->setBody($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerItemMessageId($value);
				break;
  
			case 1:
				$this->setTrackerItemId($value);
				break;
  
			case 2:
				$this->setSubmittedBy($value);
				break;
  
			case 3:
				$this->setAdddate($value);
				break;
  
			case 4:
				$this->setBody($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerItemMessagePeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerItemMessagePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerItemMessagePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTrackerItem !== null) {
				if ($this->aTrackerItem->isModified()) $this->aTrackerItem->save($con);
				$this->setTrackerItem($this->aTrackerItem);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerItemMessagePeer::doInsert($this, $con);
					$this->setTrackerItemMessageId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerItemMessagePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerItemMessagePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTrackerItem !== null) {
				if (($retval = $this->aTrackerItem->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerItemMessagePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_item_message_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerItemMessageId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerItemMessageId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerItemMessage Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerItemMessage();
		$copyObj->setTrackerItemId($this->tracker_item_id);
		$copyObj->setSubmittedBy($this->submitted_by);
		$copyObj->setAdddate($this->adddate);
		$copyObj->setBody($this->body);
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerItemMessageId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerItemMessagePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerItemMessagePeer();
		}
		return self::$peer;
	}

}
