<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing TrackerExtraField
//
require_once('plugins/tracker/lib/TrackerExtraFieldPeer.php');
require_once('plugins/tracker/lib/TrackerExtraField.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$TrackerExtraField = TrackerExtraFieldPeer::retrieveByPk($_REQUEST['tracker_extra_field_id']);
if (!is_object($TrackerExtraField)) {
	throw new PermissionDeniedException();
}
$Tracker=$TrackerExtraField->getTracker();
if (!is_object($Tracker) || !$Tracker->userIsAdmin()) {
	throw new PermissionDeniedException();
}
$obj = $TrackerExtraField;
$theme->addBreadCrumb('<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse').'&amp;tracker_id='.$Tracker->getTrackerID() .'">'. $Lang->getText('TrackerExtraField.Edit') .'</a>');

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('TrackerExtraField.EditPageTitle')
		);

$tracker_id = $Tracker->getTrackerId();
$field_type=$obj->getFieldType();
$field_name = ( (isset($_POST) && isset($_POST['field_name'])) ? htmlspecialchars($_POST['field_name']) : $obj->getFieldName() );
$attribute1 = ( (isset($_POST) && isset($_POST['attribute1'])) ? htmlspecialchars($_POST['attribute1']) : $obj->getAttribute1() );
$attribute2 = ( (isset($_POST) && isset($_POST['attribute2'])) ? htmlspecialchars($_POST['attribute2']) : $obj->getAttribute2() );
$is_required = ( (isset($_POST) && isset($_POST['is_required'])) ? htmlspecialchars($_POST['is_required']) : $obj->getIsRequired() );
$alias = ( (isset($_POST) && isset($_POST['alias'])) ? htmlspecialchars($_POST['alias']) : $obj->getAlias() );
$field_order = ( (isset($_POST) && isset($_POST['field_order'])) ? htmlspecialchars($_POST['field_order']) : $obj->getFieldOrder() );
$use_in_quick_browse = ( (isset($_POST) && isset($_POST['use_in_quick_browse'])) ? htmlspecialchars($_POST['use_in_quick_browse']) : $obj->getUseInQuickBrowse() );
$show_on_submit = ( (isset($_POST) && isset($_POST['show_on_submit'])) ? htmlspecialchars($_POST['show_on_submit']) : $obj->getShowOnSubmit() );
$default_value = ( (isset($_POST) && isset($_POST['default_value'])) ? htmlspecialchars($_POST['default_value']) : $obj->getDefaultValue() );

include ('forms/TrackerExtraFieldEdit-tpl.php');

?>
