<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-13
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/tracker/lib/Tracker.php');
require_once('lib/graphics/GraphicPie.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$user = $session->getUser();

$Project = GFUrl::getUrl()->getProject();
$project_id = $Project->getProjectId();

$Priorities = Tracker::getPriorities();

$subprojects=((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );
// Get all valid Project Ids
$all_ids = array();
if ($subprojects == 1) {
	$all_ids = $Project->getAllSubprojectIds();
	$all_ids[] = $project_id;
} else {
	$all_ids[] = $project_id;
}

if (!isset($_GET['tracker_id']) || $_GET['tracker_id'] == 0) {
	$sqlaux = " AND t.project_id IN (".implode(',',$all_ids).") ";
} else {
	$sqlaux = " AND t.tracker_id = '".$_GET['tracker_id']."'";
}

$sqlmine = '';
$user_id=((isset($_REQUEST['user_id'])) ? Validator::sanitizeInt($_REQUEST['user_id']) : 0 );
$priority=((isset($_REQUEST['priority'])) ? Validator::sanitizeInt($_REQUEST['priority']) : 0 );
$status = ((isset($_REQUEST['status'])) ? Validator::sanitizeInt($_REQUEST['status']) : 0 );

if ($user_id) {
	$sqlmine .= "AND (ti.submitted_by = $user_id OR
	ti.tracker_item_id IN (SELECT tracker_item_id FROM tracker_item_assignee
	WHERE assignee=$user_id))";
}


if ($priority)	{
	$sqlmine .= " AND ti.priority = $priority";	
}

if ($status > 0)	{
	$sqlmine .= " AND ti.status_id = " . ($status - 1);	
}

$sql = "SELECT ti.priority, COUNT(*) AS count FROM tracker t, project p, tracker_item ti
	WHERE ti.tracker_id = t.tracker_id AND t.project_id = p.project_id
	$sqlaux
	$sqlmine
	GROUP BY ti.priority ORDER BY count DESC";

$gp = new GraphicPie($Lang->getText('TrackerReporting.ByPriority'), 400, 250);
$gp->setSQL($sql);
$gp->setSQLFields('priority', 'count');
$gp->setAuxValue1($Priorities);
$gp->setLegendFormat('$legend = $this->auxvalue1[intval($key)]. \': \'.$val;');
$gp->showPie();
?>
