<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';
 

// (on-demand) include_once 'plugins/userwiki/lib/WikiPage.php';
// (on-demand) include_once 'plugins/userwiki/lib/WikiPagePeer.php';

include_once 'plugins/userwiki/lib/WikiVersionPeer.php';

/**
 * Base class that represents a row from the 'wiki_version' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to WikiVersion class. 
 * 
 * @package plugins.wiki.lib 
 */
abstract class BaseUserWikiVersion extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var UserWikiVersionPeer
	 */
	protected static $peer;

	/**
	 * The value for the wiki_version_id field.
	 * @var int	  
	 */
	protected $wiki_version_id;	

	/**
	 * The value for the wiki_page_id field.
	 * @var int	  
	 */
	protected $wiki_page_id;	

	/**
	 * The value for the page_version field.
	 * @var int	  
	 */
	protected $page_version;	

	/**
	 * The value for the posted_by field.
	 * @var int	  
	 */
	protected $posted_by;	

	/**
	 * The value for the refs field.
	 * @var string	  
	 */
	protected $refs;	

	/**
	 * The value for the last_modified_date field.
	 * @var int	  
	 */
	protected $last_modified_date = 1144198554;	

	/**
	 * The value for the score field.
	 * @var int	  
	 */
	protected $score;	

	/**
	 * The value for the hits field.
	 * @var int	  
	 */
	protected $hits;	

	/**
	 * The value for the create_date field.
	 * @var int	  
	 */
	protected $create_date;	
  
	/**
	 * Get the WikiVersionId column value.
	 *  
	 * @return int	  
	 */
	public function getWikiVersionId()
	{
		return $this->wiki_version_id;
	}


	/**
	 * Set the value of `wiki_version_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setWikiVersionId($v)
	{
		if ($this->wiki_version_id !== $v) {
			$this->wiki_version_id = $v;
			$this->modifiedColumns[] = UserWikiVersionPeer::WIKI_VERSION_ID;
		}
				
	}

  
	/**
	 * Get the WikiPageId column value.
	 *  
	 * @return int	  
	 */
	public function getWikiPageId()
	{
		return $this->wiki_page_id;
	}


	/**
	 * Set the value of `wiki_page_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setWikiPageId($v)
	{
		if ($this->wiki_page_id !== $v) {
			$this->wiki_page_id = $v;
			$this->modifiedColumns[] = UserWikiVersionPeer::WIKI_PAGE_ID;
		}
			
		if ($this->aWikiPage !== null && $this->aWikiPage->getWikiPageId() !== $v) {
			$this->aWikiPage = null;
		}
			
	}

  
	/**
	 * Get the PageVersion column value.
	 *  
	 * @return int	  
	 */
	public function getPageVersion()
	{
		return $this->page_version;
	}


	/**
	 * Set the value of `page_version` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setPageVersion($v)
	{
		if ($this->page_version !== $v) {
			$this->page_version = $v;
			$this->modifiedColumns[] = UserWikiVersionPeer::PAGE_VERSION;
		}
				
	}

  
	/**
	 * Get the PostedBy column value.
	 *  
	 * @return int	  
	 */
	public function getPostedBy()
	{
		return $this->posted_by;
	}


	/**
	 * Set the value of `posted_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setPostedBy($v)
	{
		if ($this->posted_by !== $v) {
			$this->posted_by = $v;
			$this->modifiedColumns[] = UserWikiVersionPeer::POSTED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the Refs column value.
	 *  
	 * @return string	  
	 */
	public function getRefs()
	{
		return $this->refs;
	}


	/**
	 * Set the value of `refs` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setRefs($v)
	{
		if ($this->refs !== $v) {
			$this->refs = $v;
			$this->modifiedColumns[] = UserWikiVersionPeer::REFS;
		}
				
	}


	/**
	 * Get the [optionally formatted] `last_modified_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getLastModifiedDate($format = 'Y-m-d H:i:s')
	{
		if ($this->last_modified_date === null || $this->last_modified_date === '') {
			return null;
		} elseif (!is_int($this->last_modified_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->last_modified_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of last_modified_date as date/time value: " . var_export($this->last_modified_date, true));
			}
		} else {
			$ts = $this->last_modified_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `last_modified_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setLastModifiedDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for last_modified_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->last_modified_date !== $ts || $ts === 1144198554) {
			$this->last_modified_date = $ts;
			$this->modifiedColumns[] = UserWikiVersionPeer::LAST_MODIFIED_DATE;
		}
		
	}

  
	/**
	 * Get the Score column value.
	 *  
	 * @return int	  
	 */
	public function getScore()
	{
		return $this->score;
	}


	/**
	 * Set the value of `score` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setScore($v)
	{
		if ($this->score !== $v) {
			$this->score = $v;
			$this->modifiedColumns[] = UserWikiVersionPeer::SCORE;
		}
				
	}

  
	/**
	 * Get the Hits column value.
	 *  
	 * @return int	  
	 */
	public function getHits()
	{
		return $this->hits;
	}


	/**
	 * Set the value of `hits` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setHits($v)
	{
	}


	/**
	 * Get the [optionally formatted] `create_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreateDate($format = 'Y-m-d H:i:s')
	{
		if ($this->create_date === null || $this->create_date === '') {
			return null;
		} elseif (!is_int($this->create_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->create_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of create_date as date/time value: " . var_export($this->create_date, true));
			}
		} else {
			$ts = $this->create_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `create_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setCreateDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for create_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->create_date !== $ts) {
			$this->create_date = $ts;
			$this->modifiedColumns[] = UserWikiVersionPeer::CREATE_DATE;
		}
		
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->wiki_version_id = $rs->getInt($startcol + 0);					
			$this->wiki_page_id = $rs->getInt($startcol + 1);					
			$this->page_version = $rs->getInt($startcol + 2);					
			$this->posted_by = $rs->getInt($startcol + 3);					
			$this->refs = $rs->getString($startcol + 4);					
			$this->last_modified_date = $rs->getTimestamp($startcol + 5, null);
			$this->score = $rs->getInt($startcol + 6);					
			$this->create_date = $rs->getTimestamp($startcol + 7, null);
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating WikiVersion object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(UserWikiVersionPeer::DATABASE_NAME);
		$criteria->add(UserWikiVersionPeer::WIKI_VERSION_ID, $this->wiki_version_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(UserWikiVersionPeer::DATABASE_NAME);
		if ($this->isColumnModified(UserWikiVersionPeer::WIKI_VERSION_ID)) $criteria->add(UserWikiVersionPeer::WIKI_VERSION_ID, $this->wiki_version_id);
		if ($this->isColumnModified(UserWikiVersionPeer::WIKI_PAGE_ID)) $criteria->add(UserWikiVersionPeer::WIKI_PAGE_ID, $this->wiki_page_id);
		if ($this->isColumnModified(UserWikiVersionPeer::PAGE_VERSION)) $criteria->add(UserWikiVersionPeer::PAGE_VERSION, $this->page_version);
		if ($this->isColumnModified(UserWikiVersionPeer::POSTED_BY)) $criteria->add(UserWikiVersionPeer::POSTED_BY, $this->posted_by);
		if ($this->isColumnModified(UserWikiVersionPeer::REFS)) $criteria->add(UserWikiVersionPeer::REFS, $this->refs);
		if ($this->isColumnModified(UserWikiVersionPeer::LAST_MODIFIED_DATE)) $criteria->add(UserWikiVersionPeer::LAST_MODIFIED_DATE, $this->last_modified_date);
		if ($this->isColumnModified(UserWikiVersionPeer::SCORE)) $criteria->add(UserWikiVersionPeer::SCORE, $this->score);
		if ($this->isColumnModified(UserWikiVersionPeer::CREATE_DATE)) $criteria->add(UserWikiVersionPeer::CREATE_DATE, $this->create_date);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setPostedBy(NULL);
		} else {
			$this->setPostedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->posted_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->posted_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->posted_by, $con);
			   $obj->addWikiVersions($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setPostedBy( (int) $key);			
		
	}

	/**
	 * @var WikiPage	  
	 */
	protected $aWikiPage;

	/**
	 * Declares an association between this object and a WikiPage object
	 *
	 * @param WikiPage $v
	 * @return void
	 * @throws PropelException
	 */
	public function setWikiPage($v)
	{
			
		if ($v === null) {
			$this->setWikiPageId(NULL);
		} else {
			$this->setWikiPageId($v->getWikiPageId());
		}
   
		$this->aWikiPage = $v;
	}


	/**
	 * Get the associated WikiPage object
	 *
	 * @param Connection Optional Connection object.
	 * @return WikiPage The associated WikiPage object.
	 * @throws PropelException
	 */
	public function getWikiPage($con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiPagePeer.php';

		if ($this->aWikiPage === null && ($this->wiki_page_id !== null)) {
	
			$this->aWikiPage = UserWikiPagePeer::retrieveByPK($this->wiki_page_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserWikiPagePeer::retrieveByPK($this->wiki_page_id, $con);
			   $obj->addWikiVersions($this);
			 */
		}
		return $this->aWikiPage;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setWikiPageKey($key)
	{

		$this->setWikiPageId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("wiki_version_id", "wiki_page_id", "page_version", "posted_by", "refs", "last_modified_date", "score", "hits", "create_date", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case UserWikiVersionPeer::WIKI_VERSION_ID:
				return $this->getWikiVersionId();
				break;
		  
			case UserWikiVersionPeer::WIKI_PAGE_ID:
				return $this->getWikiPageId();
				break;
		  
			case UserWikiVersionPeer::PAGE_VERSION:
				return $this->getPageVersion();
				break;
		  
			case UserWikiVersionPeer::POSTED_BY:
				return $this->getPostedBy();
				break;
		  
			case UserWikiVersionPeer::REFS:
				return $this->getRefs();
				break;
		  
			case UserWikiVersionPeer::LAST_MODIFIED_DATE:
				return $this->getLastModifiedDate();
				break;
		  
			case UserWikiVersionPeer::SCORE:
				return $this->getScore();
				break;
		  
			case UserWikiVersionPeer::HITS:
				return $this->getHits();
				break;
		  
			case UserWikiVersionPeer::CREATE_DATE:
				return $this->getCreateDate();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getWikiVersionId();
				break;
  
			case 1:
				return $this->getWikiPageId();
				break;
  
			case 2:
				return $this->getPageVersion();
				break;
  
			case 3:
				return $this->getPostedBy();
				break;
  
			case 4:
				return $this->getRefs();
				break;
  
			case 5:
				return $this->getLastModifiedDate();
				break;
  
			case 6:
				return $this->getScore();
				break;
  
			case 7:
				return $this->getHits();
				break;
  
			case 8:
				return $this->getCreateDate();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(UserWikiVersionPeer::WIKI_VERSION_ID, $arr)) $this->setWikiVersionId($arr[UserWikiVersionPeer::WIKI_VERSION_ID]);
  
		if (array_key_exists(UserWikiVersionPeer::WIKI_PAGE_ID, $arr)) $this->setWikiPageId($arr[UserWikiVersionPeer::WIKI_PAGE_ID]);
  
		if (array_key_exists(UserWikiVersionPeer::PAGE_VERSION, $arr)) $this->setPageVersion($arr[UserWikiVersionPeer::PAGE_VERSION]);
  
		if (array_key_exists(UserWikiVersionPeer::POSTED_BY, $arr)) $this->setPostedBy($arr[UserWikiVersionPeer::POSTED_BY]);
  
		if (array_key_exists(UserWikiVersionPeer::REFS, $arr)) $this->setRefs($arr[UserWikiVersionPeer::REFS]);
  
		if (array_key_exists(UserWikiVersionPeer::LAST_MODIFIED_DATE, $arr)) $this->setLastModifiedDate($arr[UserWikiVersionPeer::LAST_MODIFIED_DATE]);
  
		if (array_key_exists(UserWikiVersionPeer::SCORE, $arr)) $this->setScore($arr[UserWikiVersionPeer::SCORE]);
  
		if (array_key_exists(UserWikiVersionPeer::CREATE_DATE, $arr)) $this->setCreateDate($arr[UserWikiVersionPeer::CREATE_DATE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case UserWikiVersionPeer::WIKI_VERSION_ID:
				$this->setWikiVersionId($value);
				break;
	  
			case UserWikiVersionPeer::WIKI_PAGE_ID:
				$this->setWikiPageId($value);
				break;
	  
			case UserWikiVersionPeer::PAGE_VERSION:
				$this->setPageVersion($value);
				break;
	  
			case UserWikiVersionPeer::POSTED_BY:
				$this->setPostedBy($value);
				break;
	  
			case UserWikiVersionPeer::REFS:
				$this->setRefs($value);
				break;
	  
			case UserWikiVersionPeer::LAST_MODIFIED_DATE:
				$this->setLastModifiedDate($value);
				break;
	  
			case UserWikiVersionPeer::SCORE:
				$this->setScore($value);
				break;
	  
			case UserWikiVersionPeer::HITS:
				$this->setHits($value);
				break;
	  
			case UserWikiVersionPeer::CREATE_DATE:
				$this->setCreateDate($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setWikiVersionId($value);
				break;
  
			case 1:
				$this->setWikiPageId($value);
				break;
  
			case 2:
				$this->setPageVersion($value);
				break;
  
			case 3:
				$this->setPostedBy($value);
				break;
  
			case 4:
				$this->setRefs($value);
				break;
  
			case 5:
				$this->setLastModifiedDate($value);
				break;
  
			case 6:
				$this->setScore($value);
				break;
  
			case 7:
				$this->setHits($value);
				break;
  
			case 8:
				$this->setCreateDate($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserWikiVersionPeer::DATABASE_NAME);

		try {
			$con->begin();
			UserWikiVersionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserWikiVersionPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}
 
			if ($this->aWikiPage !== null) {
				if ($this->aWikiPage->isModified()) $this->aWikiPage->save($con);
				$this->setWikiPage($this->aWikiPage);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserWikiVersionPeer::doInsert($this, $con);
					$this->setWikiVersionId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					UserWikiVersionPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return UserWikiVersionPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aWikiPage !== null) {
				if (($retval = $this->aWikiPage->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = UserWikiVersionPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed wiki_version_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setWikiVersionId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getWikiVersionId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return WikiVersion Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new WikiVersion();
		$copyObj->setWikiPageId($this->wiki_page_id);
		$copyObj->setPageVersion($this->page_version);
		$copyObj->setPostedBy($this->posted_by);
		$copyObj->setRefs($this->refs);
		$copyObj->setLastModifiedDate($this->last_modified_date);
		$copyObj->setScore($this->score);
		$copyObj->setHits($this->hits);
		$copyObj->setCreateDate($this->create_date);
		
		$copyObj->setNew(true);
		
		$copyObj->setWikiVersionId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return UserWikiVersionPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserWikiVersionPeer();
		}
		return self::$peer;
	}

}
