<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');
require_once('plugins/userwiki/lib/Wiki.php');

//require_once('html/MyTemplate.php');

$components = GFUrl::getUrl()->getURI();
$arr = explode('/',$components);
if (in_array('my',$arr)) {
	require_once('plugins/userwiki/lib/html/WikiMyTemplate.php');
	$theme = new WikiMyTemplate();
} else {
	require_once('plugins/userwiki/lib/html/WikiUserTemplate.php');
	$theme = new WikiUserTemplate();
}

$user = GFUrl::getUrl()->getUser();

$pagename = (isset($_REQUEST['pagename'])) ? Validator::sanitizeString($_REQUEST['pagename']) : null;
$parent_page = (isset($_REQUEST['parent_page'])) ? Validator::sanitizeString($_REQUEST['parent_page']) : null;
$pageid = (isset($_REQUEST['pageid'])) ? Validator::sanitizeInt($_REQUEST['pageid']) : null;
$version = (isset($_REQUEST['version'])) ? Validator::sanitizeInt($_REQUEST['version']) : null;

$section = User::SECTION; // This should be changed if were in the user wiki wwwlib, for example
$ref_id = $user->getUserId(); // This should be changed if were in the user wiki wwwlib, for example

$wiki = new UserWiki($section,$ref_id,$theme,$user);

if ($pageid) {
	// display page or display create-page page
	if ($version) {
		$PageContent = $wiki->displayPageById($pageid,$version);
	} else {
		$PageContent = $wiki->displayPageById($pageid);
	}
} elseif ($pagename) {
	// display page or display create-page page
	if ($version) {
		$PageContent = $wiki->displayPage($pagename,$version);
	} else {
		if ($parent_page) {
			$PageContent = $wiki->displayPage($pagename,null,null,$parent_page);
		} else {
			$PageContent = $wiki->displayPage($pagename);
		}
	}
} else {
	$PageContent = $wiki->displayFrontPage();
}

$params = array(
		'user' => $user,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? Validator::sanitizeString($_REQUEST['feedback']) : (isset($feedback) ? $feedback : ''),
		'title' => Language::getSessText('Wiki.ViewPageTitle'),
		'wiki' => $wiki,
		'selectedbottomtab' => 'userwiki'
		);

$theme->header($params);

echo $PageContent;

$theme->footer();
?>
