<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-16
 *
 * MS Project plugin for GForge5.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$plugin_version = '0'; // plugin version of the client
$server_version = '1301'; // latest plugin version supported without dots, always 4 numbers
						  // 1: version, 2: minor vers, 3 and 4: revision (with leading zero)

require_once('msp.php');

Session::getSession()->terminate();
$_send_task_email = false;

function getStringFromRequest($name) {
	$result = false;
	if (isset($_GET[$name])) {
		if (trim($_GET[$name]) == '') {
			$result = true;
		} else {
			$result = $_GET[$name];
		}
	} else if (isset($_POST[$name])) {
		if (trim($_POST[$name]) == '') {
			$result = true;
		} else {
			$result = $_POST[$name];
		}
	}
	return $result;
}

$send_task_email=false;

if (getStringFromRequest('showform')) {
?>
	<html>
	<title>XML Parser</title>
	<body>
	<h2>XML Parser</h2>
	<p>
	<form name="xmlparser" method="POST" action="/gf/xmlcompatibility/msproject/">
	Text: <br />
	<textarea name="document" cols="50" rows="10"></textarea>
	<br />
	<input type="hidden" name="parser" value="yes"/>
	<?php echo HTMLWidget::button("submi", "Parser"); ?>
	</form>
	<?php
} elseif (getStringFromRequest("parser") == "yes") {
	$data = getStringFromRequest("document");
} else {
	if (!isset($data)) {
		$data = '';
		$ph = fopen("php://input", "rb");
		while (!feof($ph)) {
			$data .= fread($ph, 4096);
		}
	}
}

if (!isset($data)) {
	echo "No Data";
	exit;
}

header('Content-type: text/xml');

// SECTION 1. DEBUG XML
$data = str_replace("</ ","</",$data);
$data = str_replace("</ ","</",$data);
$data = str_replace("\r","",$data);
$data = str_replace('<notes>', '<notes><![CDATA[', $data);
$data = str_replace('</notes>', ']]></notes>', $data);

//SECTION 2. 
//FUNCTIONS AND VARIABLES
$result = array();
global $principal_tag;
global $principal_action;
global $subproject_id;
global $tag_aux;

//TASKS VARIABLES
global $tasks;
global $atasks;
global $task_id;
global $project_id;
global $parent_task_id;
global $parent_project_id;
global $isnew;
global $task_count;
global $resourcename;
global $fdependenton;
global $iddependenton;
global $adependenton;
global $projectiddependenton;
global $linktypedependenton;
global $percent_effort; // Added by Ruben

$task_count = 0;
$tasks = false;
$fdependenton = false;

function startElement($parser, $name, $attrib) {
	global $plugin_version;

    global $principal_tag;
    global $principal_action;
    global $subproject_id;
    global $task_id;
    global $project_id;
    global $parent_task_id;
    global $parent_project_id;
    global $isnew;
    global $task_count;
    global $tasks;
    global $fdependenton;
    global $result;
    global $tag_aux;
    global $iddependenton;
    global $projectiddependenton;
    global $linktypedependenton;
    global $percent_effort; // Added by Ruben
   	
    $tag_aux = $name;
	if ($tasks == true){

		// Added by Ruben
	   	if ($name=="RESOURCENAME") {
			if (isset($attrib["EFFORT"])) {
				$percent_effort = $attrib["EFFORT"];
			} else {
				$percent_effort = 100;
			}
		} //

		//ID TASK
		if ($name == "TASK") {
/*			$task_id = $attrib["ID"];
			$project_id = $attrib["PROJECTID"];
			$parent_task_id = $attrib["PARENT_TASK_ID"];
			$parent_project_id = $attrib["PARENT_PROJECT_ID"];
			$isnew = $attrib["ISNEW"];
*/
			if ($fdependenton == true){
				$iddependenton = $attrib["ID"];
				$projectiddependenton = $attrib["PROJECTID"];
				$linktypedependenton= $attrib["LINKTYPE"];
			}
		}
		if ($name == "DEPENDENTON") {
			$fdependenton = true;
		}
		return;
	}
	
	if (isset($attrib["VERSION"])) {
		$plugin_version = $attrib["VERSION"];
	}
	
    switch ($name){
	    case $name=="REQUEST" : {
		    switch ($attrib["HANDLE"]){
				case $attrib["HANDLE"] == "GetSubprojects": {
					$principal_tag = $attrib["HANDLE"];
					$result[$name] = $principal_tag;
					break;
				}
				case $attrib["HANDLE"] == "upload": {
					$principal_tag = $attrib["HANDLE"];
					$result[$name] = $principal_tag;
					$result["ACTION"] = $attrib["ACTION"];;
					break;
				}
				case $attrib["HANDLE"] == "download": {
					$principal_tag = $attrib["HANDLE"];
					$result[$name] = $principal_tag;
					$result["ACTION"] = $attrib["ACTION"];
					break;
				}
				case $attrib["HANDLE"] == "GetProjects": {
					$principal_tag = $attrib["HANDLE"];
					$result[$name] = $principal_tag;
					break;
				}
				case $attrib["HANDLE"] == "CreateProject": {
					$principal_tag = $attrib["HANDLE"];
					$result[$name] = $principal_tag;
					$result["GROUPID"] = $attrib["GROUPID"];
					break;
				}
			}
	    	break;
    	}
	   	case $name=="SUBPROJECT" : {
			$subproject_id = $attrib["ID"];
			break;
		}
	   	case $name=="TASKS" : {
		   	$tasks = true;
			break;
		}
	}
}

function endElement($parser, $name) {
	global $task_count;
	global $iddependenton;
	global $fdependenton;
	global $result;
	global $atasks;
	global $resourcename;
	global $principal_tag;
	global $adependenton;
	global $result;

	if ($name == "TASK" && $principal_tag=="upload" && ($fdependenton == false)) {
		$task_count++;
		$atasks["resources"] = $resourcename;
		$resourcename = array();
	}
	if ($name == "TASK" && $principal_tag=="upload" && ($fdependenton == false)) {
		$result["tasks"][] = $atasks;
		$atasks=array();
	}
	if ($name == "DEPENDENTON" && $principal_tag=="upload"){
		$fdependenton = false;
		$atasks["dependenton"] = $adependenton;
		$adependenton = array();
	}

}

function characterDataHandler ($parser, $data) {
	global $principal_tag;
	global $subproject_id;
	global $result;
	global $tag_aux;
	global $task_count;
	global $task_id;
	global $project_id;
	global $parent_task_id;
	global $parent_project_id;
	global $isnew;
	global $atasks;
	global $fdependenton;
	global $iddependenton;
	global $adependenton;
   	global $projectiddependenton;
   	global $linktypedependenton;
	global $resourcename;
	global $percent_effort; // Added by Ruben

	if (!$principal_tag) {return;}
	if (!$tag_aux) {return;}

	switch ($principal_tag){
		case $principal_tag == "GetSubprojects": {
			switch ($tag_aux){
				case $tag_aux == "LOGINID": {
					$result["loginid"] = $data;
					break;
				}
				case $tag_aux == "PASSWORD": {
					$result["password"] = $data;
					break;
				}
			}
			$tag_aux = "";
			break;
		}
		
		case $principal_tag == "download": {
			switch ($tag_aux) {
				case $tag_aux == "SESSION_ID": {
					$result["session_id"] = $data;
					break;
				}
				case $tag_aux == "SUBPROJECT": {
					$result["subproject"][] = array("id"=>$subproject_id,"name"=>$data);
					break;
				}
			}
			$tag_aux = "";
			break;
		}
		
		case  $principal_tag == "GetProjects": {
                        switch ($tag_aux) {
				case $tag_aux == "SESSION_ID": {
					$result["session_id"] = $data;
					break;
				}
			}
		}

		case  $principal_tag == "CreateProject": {
			switch ($tag_aux) {
				case $tag_aux == "SESSION_ID": {
					$result["session_id"] = $data;
					break;
				}
				case $tag_aux == "NAME": {
					$result["name"] = $data;
					break;
				}
				case $tag_aux == "ISPUBLIC": {
					$result["ispublic"] = $data;
					break;
				}
				case $tag_aux == "DESCRIPTION": {
					$result["description"] = $data;
					break;
				}
			}
		}

		case $principal_tag == "upload": {
			switch ($tag_aux) {
				case $tag_aux == "SESSION_ID": {
					$result["session_id"] = $data;
					break;
				}
				case $tag_aux == "SUBPROJECT": {
					$result["subproject"][] = array("id"=>$subproject_id,"name"=>$data);
					break;
				}
				case $tag_aux == "TASK": {
					if ($fdependenton == true) {
						$adependenton[] = array("task_id"=>$iddependenton,"msproj_id"=>$projectiddependenton,"link_type"=>$linktypedependenton,"task_name"=>$data);
					} else {
						$atasks = Array();
/*
						$atasks["id"] = $task_id;
						$atasks["msproj_id"] = $project_id;
						$atasks["parent_id"] = $project_task_id;
						$atasks["parent_msproj_id"] = $parent_project_id;
						$atasks["isnew"] = $isnew;
*/
					}
					break;
				}
				case $tag_aux == "ID": {
					$atasks["id"] = trim($data);
					break;
				}
				case $tag_aux == "PARENT_TASK_ID": {
					$atasks["parent_task_id"] = trim($data);
					break;
				}
				case $tag_aux == "PROJECTID": {
					$atasks["msproj_id"] = trim($data);
					break;
				}
				case $tag_aux == "PARENT_PROJECT_ID": {
					$atasks["parent_msproj_id"] = trim($data);
					break;
				}
				case $tag_aux == "ISNEW": {
					$atasks["isnew"] = trim($data);
					break;
				}
				case $tag_aux == "NAME": {
					$atasks["name"] = trim($data);
					break;
				}
				case $tag_aux == "WORK": {
					$atasks["work"] = trim($data);
					break;
				}
				case $tag_aux == "START_DATE": {
					$atasks["start_date"] = trim($data);
					break;
				}
				case $tag_aux == "END_DATE": {
					$atasks["end_date"] = trim($data);
					break;
				}
				case $tag_aux == "PERCENT_COMPLETE": {
					$atasks["percent_complete"] = trim($data);
					break;
				}
				case $tag_aux == "DURATION": {
					$atasks["duration"] = trim($data);
					break;
				}
				case $tag_aux == "PRIORITY": {
					$atasks["priority"] = trim($data);
					break;
				}
				case $tag_aux == "RESOURCENAME": {
					$resourcename[] = array("user_name"=>$data, "percent_effort"=>$percent_effort);
					break;
				}
				case $tag_aux == "NOTES": {
					$atasks["notes"] = trim($data);
					break;
				}
			}
			$tag_aux = "";
			break;
		}
	}
}

//SECTION 3. MAIN
$xml_parser = xml_parser_create("UTF-8");
xml_set_element_handler($xml_parser, "startElement", "endElement");
xml_set_character_data_handler( $xml_parser, "characterDataHandler");

if (!xml_parse($xml_parser, $data, true)) {
	$err = sprintf("XML error: %s at line %d: %s",
	xml_error_string(xml_get_error_code($xml_parser)),
	xml_get_current_line_number($xml_parser), $data);
	die($err);
}
xml_parser_free($xml_parser);

//SECTION 4. CALL GFORGE FUNCTIONS
switch ($result["REQUEST"]) {
	//MSPLogin
	case $result["REQUEST"] == "GetSubprojects": {
		$gforgeresult = MSPLogin($result["loginid"], $result["password"]);
		print('<?xml version="1.0"?>');
		print('<xml>');
		if ($gforgeresult["success"] == true) {
			print('<response version="'.$server_version.'" handle="result">');
			print('<session_id>');
			print($gforgeresult["session_hash"]);
			print('</session_id>');
			$subprojects = $gforgeresult["subprojects"];
			print('<subprojects>');
			if (count($subprojects) > 0 ) {
				foreach($subprojects as $k => $v) {
					print('<subproject id ="'.$k.'">'.$v.'</subproject>');
				}
			}
			print('</subprojects>');
		} else {
			print('<response version="'.$server_version.'" handle="error">');
			print('<error><description>'.$gforgeresult["errormessage"].'</description></error>');
		}
		print('</response>');
		print('</xml>');
		break;
	}
	//MSPDownload
	case $result["REQUEST"] == "download": {
		if ((trim($result["ACTION"]) == "GetLatestVersion") || (trim($result["ACTION"]) == "Checkout")) {
			$gforgeresult =& MSPDownload($result["session_id"], $result["subproject"][0]["id"]);
			$return = ('<?xml version="1.0"?>');
			$return .= ('<xml>');
			if ($gforgeresult["success"] == true) {
				$return .= ('<response version="'.$server_version.'" handle="result">');
				$tasks =& $gforgeresult["tasks"];
				$return .= ('<sync_time>'.date('Y-m-d H:i:s').'</sync_time>');
				$return .= ('<tasks>');
				for ($tc=0; $tc<count($tasks); $tc++) {
					$task = $tasks[$tc];
					
					//$users = $task->getAssignedUsers();
					$users = $task->getTrackerItemAssignees();
					$extra = $task->getTrackerExtraFieldDatas();
					$extra_ids = $task->getTracker()->getTrackerExtraFields();
					$duration_id = 0;
					$complete_id = 0;
					$effort_id   = 0;
					$duration = '0';
					$complete = '0';
					$effort   = '0';
					foreach ($extra_ids as $field) {
						if ($field->getAlias() == 'duration') { $duration_id = $field->getTrackerExtraFieldId(); }
						if ($field->getAlias() == 'percentcomplete') { $complete_id = $field->getTrackerExtraFieldId(); }
						if ($field->getAlias() == 'estimatedeffort') { $effort_id = $field->getTrackerExtraFieldId(); }
					}
					foreach ($extra as $data) {
						if ($data->getTrackerExtraFieldId() == $duration_id && $data->getFieldData() != '') {
							$duration = $data->getFieldData();
						}
						if ($data->getTrackerExtraFieldId() == $complete_id && $data->getFieldData() != '') {
							$complete = $data->getFieldData();
						}
						if ($data->getTrackerExtraFieldId() == $effort_id && $data->getFieldData() != '') {
							$effort = $data->getFieldData();
						}
					}
					$return .= ('<task id="'.$task->getTrackerItemId().'" parent_task_id="'.$task->getParentId().'">');
					$return .= ('<projectid>'.$task->getSortOrder().'</projectid>');
					$return .= ('<name>'.$task->getSummary().'</name>');
					$return .= ('<start_date>'.date('Y-m-d H:i:s', $task->getOpenDate(null)).'</start_date>');
					$return .= ('<end_date>'.date('Y-m-d H:i:s', $task->getCloseDate(null)).'</end_date>');
					$return .= ('<work>'.$effort.'</work>');
					$return .= ('<duration>'.$duration.'</duration>');
					$return .= ('<percent_complete>'.$complete.'</percent_complete>');
					$return .= ('<priority>'.$task->getPriority().'</priority>');
					$return .= ('<lastmodified>');
					if ($task->getLastModifiedDate(null) != "") {
						$return .= (date('Y-m-d H:i:s', $task->getLastModifiedDate(null)));
					}
					$return .= ('</lastmodified>');
					

					if (count($users) == 1 && $users[0]->getUser()->getUserId()==100) {
						//skip if only one user - the 100 user
					} else {
						$return .= ('<resources>');
						reset($users);
						$sent_names = array();
						for ($i=0; $i<count($users); $i++) {
							$username = $users[$i]->getUser()->getUnixName();
							$effort = $users[$i]->getPercentUtilization();
							if (array_search($username, $sent_names) === false) {
								$sent_names[] = $username;
								$return .= ('<resourcename effort="'.$effort.'">'.$username.'</resourcename>');
							}
						}
						$return .= ('</resources>');
					}

					$dependenton = $task->getTrackerItemRelationsRelatedByTrackerItemId();
					if (count($dependenton) == 1 && $dependenton[0]->getRelatedTrackerItemId() == 100) {
						//skip if only one item - the 100 item
					} else {
						$return .= ('<dependenton>');
						reset($dependenton);
						for ($i=0; $i<count($dependenton); $i++) {
							$dep = $dependenton[$i];
							$return .= ('<task id="'.$dep->getRelatedTrackerItemId().'" linktype="'.$dep->getLinkType().'" />');
						}
						$return .= ('</dependenton>');
					}
					$return .= ('<notes>'.$task->getDetails().'</notes>');
					$return .= ('</task>');
				}
				$return .= ('</tasks>');
				///printr($return,'download XML');
				print $return;
			} else {
				print($return.'<response version="'.$server_version.'" handle="error">');
				print('<error><description>'.$gforgeresult["errormessage"].'</description></error>');
			}
			print('</response>');
			print('</xml>');
		}
		break;
	}
	//MSPCheckin
	case $result["REQUEST"] == "upload": {
		if (trim($result["ACTION"]) == "Checkin") {
			if (!isset($result["tasks"])) {
				$result["tasks"] = array();
			}
			$result["tasks"] = (isset($result["tasks"])) ? $result["tasks"] : array();
			$gforgeresult = MSPCheckin($result["session_id"],$result["subproject"][0]["id"],$result["tasks"]);
			print('<?xml version="1.0"?>');
			print('<xml>');
			if (!isset($gforgeresult["success"]) || ($gforgeresult["success"] == false)) {
				if (isset($gforgeresult["errormessage"]) && $gforgeresult["errormessage"] == "Invalid Resource Name") {
					print('<response version="'.$server_version.'" handle="mapuser">');
					$resourcenames = $gforgeresult["resourcename"];
					print('<resourcenames>');
					if (count($resourcenames) > 0 ) {
						foreach($resourcenames as $k => $resourcename) {
							print('<resourcename>'.$resourcename.'</resourcename>');
						}
					}
					print('</resourcenames>');
					print('<usernames>');
					$usernames = $gforgeresult["usernames"];
					if (count($usernames) > 0 ) {					
						foreach($usernames as $k => $username) {
							print('<user id ="'.$k.'">'.$username.'</user>');
						}
					}
					print('</usernames>');
				} else {
					print('<response version="'.$server_version.'" handle="error">');
					print('<error>');
					print('<description>'.$gforgeresult["errormessage"].'</description>');
					print('</error>');
				}
				print('</response>');
			} else {
				print ('<response version="'.$server_version.'" handle="result">success</response>');
			}
			print('</xml>');
		}
		if (trim($result["ACTION"]) == "Undo") {
			print('<?xml version="1.0"?>');
			print('<xml>');
				print ('<response version="'.$server_version.'" handle="result">success</response>');
			print('</xml>');
		//call MSPUNDO($result["session_id"],$result["subproject"]["id"]);
		}
		break;
	}
	//GetProjects
	case $result["REQUEST"] == "GetProjects": {
		//Call GetProjects
		$gforgeresult = MSPGetProjects($result["session_id"]);
		print('<?xml version="1.0"?>');
		print('<xml>');
		
		if ($gforgeresult["success"] == true) {
			print('<response version="'.$server_version.'" handle="result">');
			print('<projects>');
			$projects = $gforgeresult["projects"];
			if (count($projects) > 0 ) {
				foreach($projects as $k => $v) {
					print('<project id ="'.$k.'">'.$v.'</project>');
				}
			}
			print('</projects>');
		} else {
			print('<response version="'.$server_version.'" handle="error">');
			print('<error><description>'.$gforgeresult["errormessage"].'</description></error>');
		}
		print('</response>');
		print('</xml>');
		break;
	}
	//CreateProject
	case $result["REQUEST"] == "CreateProject": {
		if (strtolower($result["ispublic"]) == 'true') {
			$result["ispublic"]=1;
		} else { 
			$result["ispublic"]=0;
		}
		$gforgeresult = MSPCreateProject($result["GROUPID"],$result["session_id"],$result["name"],$result["ispublic"],$result["description"]);
		print('<?xml version="1.0"?>');
		print('<xml>');
		if (!is_object($gforgeresult) && $gforgeresult['code'] == 'error') {
			print('<response version="'.$server_version.'" handle="error">');
			print('<error>');
			print('<description>'.$gforgeresult['description'].'</description>');
			print('</error>');
		} else { 
			print('<response version="'.$server_version.'" handle="result">');
			print('<Group_ID>'.$result['GROUPID'].'</Group_ID>');
			print('<Group_Project_ID>'.$gforgeresult->getTrackerId().'</Group_Project_ID>');
		}
		print('</response>');
		print('</xml>');
		break;
	}
}
?>
