<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

// This code generates a SOAP API for handling TrackerItem

require_once('plugins/tracker/lib/TrackerItem.php');
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('Validator.php');

/* ******************************************************************** */
/*                                 DATA TYPES                           */
/* ******************************************************************** */
$server->wsdl->addComplexType(
	'TrackerItem',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'tracker_id' => array('name'=>'tracker_id', 'type' => 'xsd:int'),
		'tracker_item_id' => array('name'=>'tracker_item_id', 'type' => 'xsd:int'),
		'status_id' => array('name'=>'status_id', 'type' => 'xsd:int'),
		'priority' => array('name'=>'priority', 'type' => 'xsd:int'),
		'submitted_by' => array('name'=>'submitted_by', 'type' => 'xsd:int'),
		'open_date' => array('name'=>'open_date', 'type' => 'xsd:string'),
		'close_date' => array('name'=>'close_date', 'type' => 'xsd:string'),
		'summary' => array('name'=>'summary', 'type' => 'xsd:string'),
		'details' => array('name'=>'details', 'type' => 'xsd:string'),
		'last_modified_date' => array('name'=>'last_modified_date', 'type' => 'xsd:string'),
		'last_modified_by' => array('name'=>'last_modified_by', 'type' => 'xsd:int'),
		'sort_order' => array('name'=>'sort_order', 'type' => 'xsd:int'),
		'parent_id' => array('name'=>'parent_id', 'type' => 'xsd:int')
	)
);


$server->wsdl->addComplexType(
	'ArrayOfTrackerItem',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:TrackerItem[]')),
	'tns:TrackerItem'
);


$server->wsdl->addComplexType(
	'TrackerItemFull',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'tracker_id' => array('name'=>'tracker_id', 'type' => 'xsd:int'),
		'tracker_item_id' => array('name'=>'tracker_item_id', 'type' => 'xsd:int'),
		'status_id' => array('name'=>'status_id', 'type' => 'xsd:int'),
		'priority' => array('name'=>'priority', 'type' => 'xsd:int'),
		'submitted_by' => array('name'=>'submitted_by', 'type' => 'xsd:int'),
		'open_date' => array('name'=>'open_date', 'type' => 'xsd:string'),
		'close_date' => array('name'=>'close_date', 'type' => 'xsd:string'),
		'summary' => array('name'=>'summary', 'type' => 'xsd:string'),
		'details' => array('name'=>'details', 'type' => 'xsd:string'),
		'last_modified_date' => array('name'=>'last_modified_date', 'type' => 'xsd:string'),
		'last_modified_by' => array('name'=>'last_modified_by', 'type' => 'xsd:int'),
		'sort_order' => array('name'=>'sort_order', 'type' => 'xsd:int'),
		'parent_id' => array('name'=>'parent_id', 'type' => 'xsd:int'),
		'extra_field_data' => array('name'=>'extra_field_data', 'type' => 'tns:ArrayOfTrackerExtraFieldData'),
		'assignees' => array('name'=>'assignees', 'type' => 'tns:ArrayOfTrackerItemAssignee'),
		'messages' => array('name'=>'messages', 'type' => 'tns:ArrayOfTrackerItemMessage'),
		'scm_commits' => array('name'=>'scm_commits', 'type' => 'tns:ArrayOfTrackerItemScmCommit'),
		'times' => array('name'=>'times', 'type' => 'tns:ArrayOfTrackerItemTime'),
		'duplicates' => array('name'=>'duplicates', 'type' => 'tns:ArrayOfTrackerItemDuplicate'),
		'relations' => array('name'=>'relations', 'type' => 'tns:ArrayOfTrackerItemRelation')
	)
);


$server->wsdl->addComplexType(
	'ArrayOfTrackerItemFull',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:TrackerItemFull[]')),
	'tns:TrackerItemFull'
);


$server->wsdl->addComplexType(
	'TrackerItemShort',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'tracker_id' => array('name'=>'tracker_id', 'type' => 'xsd:int'),
		'tracker_item_id' => array('name'=>'tracker_item_id', 'type' => 'xsd:int'),
		'status_id' => array('name'=>'status_id', 'type' => 'xsd:int'),
		'priority' => array('name'=>'priority', 'type' => 'xsd:int'),
		'submitted_by' => array('name'=>'submitted_by', 'type' => 'xsd:int'),
		'open_date' => array('name'=>'open_date', 'type' => 'xsd:string'),
		'close_date' => array('name'=>'close_date', 'type' => 'xsd:string'),
		'summary' => array('name'=>'summary', 'type' => 'xsd:string'),
		'assignees' => array('name'=>'assignees', 'type' => 'tns:ArrayOfTrackerItemAssignee')
	)
);


$server->wsdl->addComplexType(
	'ArrayOfTrackerItemShort',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:TrackerItemShort[]')),
	'tns:TrackerItemShort'
);

/* ******************************************************************** */
/*                                 METHODS                              */
/* ******************************************************************** */

$server->register(
	'getTrackerItems',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_id' => 'xsd:int',
		'status_id' => 'xsd:int',
		'priority' => 'xsd:int',
		'submitted_by' => 'xsd:int',
		'open_date' => 'xsd:string',
		'close_date' => 'xsd:string',
		'last_modified_date' => 'xsd:string',
		'last_modified_by' => 'xsd:int',
		'sort_order' => 'xsd:int',
		'parent_id' => 'xsd:int',
		'assignees' => 'tns:ArrayOfInt'
	), 
	array('getTrackerItems' => 'tns:ArrayOfTrackerItem'),
	$uri, 
	$uri.'#getTrackerItems',
	'rpc',
	'encoded'
);


/**
 * SOAP method to retrieve a list of TrackerItem
 * @param	$tracker_id	Filter by tracker_id
  * @param	$status_id	Filter by status_id
 * @param	$priority	Filter by priority
 * @param	$submitted_by	Filter by submitted_by
 * @param	$open_date	Filter by open_date
 * @param	$close_date	Filter by close_date
 * @param	$last_modified_date	Filter by last_modified_date
 * @param	$last_modified_by	Filter by last_modified_by
 * @param	$sort_order	Filter by sort_order
 * @param	$parent_id	Filter by parent_id
 * @param	$assignees	Filter by assignees
 */
function getTrackerItems($sessionHash, $tracker_id, $status_id, $priority, $submitted_by, $open_date, $close_date, $last_modified_date, $last_modified_by, $sort_order, $parent_id, $assignees) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$c = new Criteria();
	
	if ($tracker_id >= 0) {
		$c->add(TrackerItemPeer::TRACKER_ID, $tracker_id);
	}
	if ($status_id >= 0) {
		$c->add(TrackerItemPeer::STATUS_ID, $status_id);
	}
	if ($priority >= 0) {
		$c->add(TrackerItemPeer::PRIORITY, $priority);
	}
	if ($submitted_by >= 0) {
		$c->add(TrackerItemPeer::SUBMITTED_BY, $submitted_by);
	}
	if (!empty($open_date)) {
		$c->add(TrackerItemPeer::OPEN_DATE, $open_date);
	}
	if (!empty($close_date)) {
		$c->add(TrackerItemPeer::CLOSE_DATE, $close_date);
	}
	if (!empty($last_modified_date)) {
		$c->add(TrackerItemPeer::LAST_MODIFIED_DATE, $last_modified_date);
	}
	if ($last_modified_by >= 0) {
		$c->add(TrackerItemPeer::LAST_MODIFIED_BY, $last_modified_by);
	}
	if ($sort_order >= 0) {
		$c->add(TrackerItemPeer::SORT_ORDER, $sort_order);
	}
	if ($parent_id >= 0) {
		$c->add(TrackerItemPeer::PARENT_ID, $parent_id);
	}
	if (is_array($assignees) && count($assignees) > 0) {
		$c->addJoin(TrackerItemPeer::TRACKER_ITEM_ID, TrackerItemAssigneePeer::TRACKER_ITEM_ID);
		$c->add(TrackerItemAssigneePeer::ASSIGNEE, $assignees, Criteria::IN);
	}
	
	$objs = TrackerItemPeer::doSelect($c);
	$res = array();
	foreach ($objs as $obj) {
		if ($obj->userCanRead()) {
			$res[] = TrackerItemToSOAP($obj);
		}
	}
	
	return $res;
	
}


$server->register(
	'getTrackerItemsFull',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_id' => 'xsd:int',
		'tracker_item_id' => 'xsd:int',
		'status_id' => 'xsd:int',
		'priority' => 'xsd:int',
		'submitted_by' => 'xsd:int',
		'open_date' => 'xsd:string',
		'close_date' => 'xsd:string',
		'last_modified_date' => 'xsd:string',
		'last_modified_by' => 'xsd:int',
		'sort_order' => 'xsd:int',
		'parent_id' => 'xsd:int',
		'assignees' => 'tns:ArrayOfInt'
	), 
	array('getTrackerItemsFull' => 'tns:ArrayOfTrackerItemFull'),
	$uri, 
	$uri.'#getTrackerItemsFull',
	'rpc',
	'encoded'
);


/**
 * SOAP method to retrieve a list of TrackerItem
 * @param	$tracker_id	Filter by tracker_id
 * @param	$tracker_item_id	Filter by tracker_item_id
 * @param	$status_id	Filter by status_id
 * @param	$priority	Filter by priority
 * @param	$submitted_by	Filter by submitted_by
 * @param	$open_date	Filter by open_date
 * @param	$close_date	Filter by close_date
 * @param	$last_modified_date	Filter by last_modified_date
 * @param	$last_modified_by	Filter by last_modified_by
 * @param	$sort_order	Filter by sort_order
 * @param	$parent_id	Filter by parent_id
 * @param	$assignees	Filter by assignees
 */
function getTrackerItemsFull($sessionHash, $tracker_id, $tracker_item_id, $status_id, $priority, $submitted_by, $open_date, $close_date, $last_modified_date, $last_modified_by, $sort_order, $parent_id, $assignees) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$c = new Criteria();
	
	if ($tracker_item_id >= 0) {
		$c->add(TrackerItemPeer::TRACKER_ITEM_ID, $tracker_item_id);
	}
	if ($tracker_id >= 0) {
		$c->add(TrackerItemPeer::TRACKER_ID, $tracker_id);
	}
	if ($status_id >= 0) {
		$c->add(TrackerItemPeer::STATUS_ID, $status_id);
	}
	if ($priority >= 0) {
		$c->add(TrackerItemPeer::PRIORITY, $priority);
	}
	if ($submitted_by >= 0) {
		$c->add(TrackerItemPeer::SUBMITTED_BY, $submitted_by);
	}
	if (!empty($open_date)) {
		$c->add(TrackerItemPeer::OPEN_DATE, $open_date);
	}
	if (!empty($close_date)) {
		$c->add(TrackerItemPeer::CLOSE_DATE, $close_date);
	}
	if (!empty($last_modified_date)) {
		$c->add(TrackerItemPeer::LAST_MODIFIED_DATE, $last_modified_date);
	}
	if ($last_modified_by >= 0) {
		$c->add(TrackerItemPeer::LAST_MODIFIED_BY, $last_modified_by);
	}
	if ($sort_order >= 0) {
		$c->add(TrackerItemPeer::SORT_ORDER, $sort_order);
	}
	if ($parent_id >= 0) {
		$c->add(TrackerItemPeer::PARENT_ID, $parent_id);
	}
	if (is_array($assignees) && count($assignees) > 0) {
		$c->addJoin(TrackerItemPeer::TRACKER_ITEM_ID, TrackerItemAssigneePeer::TRACKER_ITEM_ID);
		$c->add(TrackerItemAssigneePeer::ASSIGNEE, $assignees, Criteria::IN);
	}
	
	$objs = TrackerItemPeer::doSelect($c);
	$res = array();
	foreach ($objs as $obj) {
		if ($obj->userCanRead()) {
			$res[] = TrackerItemToSOAP($obj, true);
		}
	}
	
	return $res;
	
}


$server->register(
	'getTrackerItemArray',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_item_id' => 'tns:ArrayOfInt',
	), 
	array('getTrackerItem' => 'tns:ArrayOfTrackerItem'),
	$uri, 
	$uri.'#getTrackerItem',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve an array of TrackerItem
 * @param	$tracker_item_id	Retrieve the TrackerItem array identified by the array of tracker_item_id
 */
function getTrackerItemArray($sessionHash, $tracker_item_idArr) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$ret = array();

	$crit=new Criteria();
	$crit->add(TrackerItemPeer::TRACKER_ITEM_ID,$tracker_item_idArr,Criteria::IN);
	$objs = TrackerItemPeer::doSelect($crit);
	foreach ($objs as $obj) {
		if ($obj->userCanRead()) {
			$ret[] = TrackerItemToSOAP($obj);
		}
	}
	return $ret;
}

$server->register(
	'getTrackerItem',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_item_id' => 'xsd:int',
	), 
	array('getTrackerItem' => 'tns:TrackerItem'),
	$uri, 
	$uri.'#getTrackerItem',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve a single TrackerItem
 * @param	$tracker_item_id	Retrieve the TrackerItem identified by this tracker_item_id
 */
function getTrackerItem($sessionHash, $tracker_item_id) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = TrackerItemPeer::retrieveByPK($tracker_item_id);
	if (is_null($obj)) {
		return null;
	}
	if (!$obj->userCanRead()) {
		return new soap_fault('', 'getTrackerItem','Permission Denied - Cannot View This Record','Permission Denied - Cannot View This Record');
	}
	return TrackerItemToSOAP($obj);
}


$server->register(
	'getTrackerItemFull',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_item_id' => 'xsd:int',
	), 
	array('getTrackerItemFull' => 'tns:TrackerItemFull'),
	$uri, 
	$uri.'#getTrackerItemFull',
	'rpc',
	'encoded'
);

/**
 * SOAP method to retrieve a single TrackerItem
 * @param	$tracker_item_id	Retrieve the TrackerItem identified by this tracker_item_id
 */
function getTrackerItemFull($sessionHash, $tracker_item_id) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = TrackerItemPeer::retrieveByPK($tracker_item_id);
	if (is_null($obj)) {
		return null;
	}
	if (!$obj->userCanRead()) {
		return new soap_fault('', 'getTrackerItem','Permission Denied - Cannot View This Record','Permission Denied - Cannot View This Record');
	}
	return TrackerItemToSOAP($obj, true);
}

$server->register(
	'deleteTrackerItem',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_item_id' => 'xsd:int',
	), 
	array('deleteTrackerItem' => 'xsd:int'),
	$uri, 
	$uri.'#deleteTrackerItem',
	'rpc',
	'encoded'
);

/**
 * SOAP method to delete a single TrackerItem
 * @param	$tracker_item_id	Delete the TrackerItem identified by this tracker_item_id
 */
function deleteTrackerItem($sessionHash, $tracker_item_id) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = TrackerItemPeer::retrieveByPK($tracker_item_id);
	if (is_null($obj)) {
		return new soap_fault('', 'deleteTrackerItem','Permission Denied - Cannot Delete This Record','Permission Denied - Cannot View This Record');
	}
	try {
		$obj->delete();
	} catch (Exception $e) {
		return new soap_fault('', 'deleteTrackerItem','Permission Denied - Cannot Delete This Record',$e->getMessage());
	}
	return 1;
}

/*

$server->register(
	'updateTrackerItem',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_item_id' => 'xsd:int',
		'status_id' => 'xsd:int',
		'priority' => 'xsd:int',
		'summary' => 'xsd:string',
		'details' => 'xsd:string',
		'sort_order' => 'xsd:int',
		'parent_id' => 'xsd:int'
	), 
	array('updateTrackerItem' => 'xsd:int'),
	$uri, 
	$uri.'#updateTrackerItem',
	'rpc',
	'encoded'
);

*/

/**
 * SOAP method to update TrackerItem
 * @param	$tracker_item_id	 TrackerItem to update
 * @param	$status_id
 * @param	$priority
 * @param	$summary
 * @param	$details
 * @param	$sort_order
 * @param	$parent_id
 * @param	$extra_field_data
 * @param	$assignees
 * @param	$relations
 */
 
/*
function updateTrackerItem($sessionHash, $tracker_item_id, $status_id, $priority, $summary, $details, $sort_order, $parent_id) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = TrackerItemPeer::retrieveByPK($tracker_item_id);
	if (is_null($obj)) {
		return new soap_fault('', 'updateTrackerItem', 'Couldn\'t update TrackerItem: invalid tracker_item_id '.$tracker_item_id);
	}
	if (!is_null($status_id)) {
		$obj->setStatusId( Validator::sanitizeInt($status_id) );
	}
	if (!is_null($priority)) {
		$obj->setPriority( Validator::sanitizeInt($priority) );
	}
	if (!is_null($summary)) {
		$obj->setSummary( Validator::sanitizeString($summary) );
	}
	if (!is_null($details)) {
		$obj->setDetails( Validator::sanitizeString($details) );
	}
	if (!is_null($sort_order)) {
		$obj->setSortOrder( Validator::sanitizeInt($sort_order) );
	}
	if (!is_null($parent_id)) {
		$obj->setParentId( Validator::sanitizeInt($parent_id) );
	}
	
	try {
		$obj->save();
	} catch (Exception $e) {
		return new soap_fault('', 'updateTrackerItem','Permission Denied - Cannot update This Record',$e->getMessage());
	}
	return 1;
}
*/

$server->register(
	'updateTrackerItemFull',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_item_id' => 'xsd:int',
		'tracker_id' => 'xsd:int',
		'status_id' => 'xsd:int',
		'priority' => 'xsd:int',
		'summary' => 'xsd:string',
		'details' => 'xsd:string',
		'sort_order' => 'xsd:int',
		'parent_id' => 'xsd:int',
		'assignees' => 'tns:ArrayOfTrackerItemAssignee',
		'open_date' => 'xsd:string',
		'close_date' => 'xsd:string',
	), 
	array('updateTrackerItemFull' => 'xsd:int'),
	$uri, 
	$uri.'#updateTrackerItemFull',
	'rpc',
	'encoded'
);

/**
 * SOAP method to update TrackerItem
 * @param	$tracker_item_id	 TrackerItem to update
 * @param   $tracker_id
 * @param	$status_id
 * @param	$priority
 * @param	$summary
 * @param	$details
 * @param	$sort_order
 * @param	$parent_id
 * @param	$assignees
 * @param	$open_date
 * @param	$close_date
 */

function updateTrackerItemFull($sessionHash, $tracker_item_id, $tracker_id, $status_id, $priority, $summary, $details, $sort_order, $parent_id, $assignees, $open_date, $close_date) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = TrackerItemPeer::retrieveByPK($tracker_item_id);
	if (is_null($obj)) return new soap_fault('', 'updateTrackerItemFull', 'Couldn\'t update TrackerItem: invalid tracker_item_id '.$tracker_item_id);

	if (!is_null($tracker_id) && $tracker_id > 0) $obj->setTrackerId( Validator::sanitizeInt($tracker_id) );
	if (!is_null($status_id) && $status_id > -1) $obj->setStatusId( Validator::sanitizeInt($status_id) );
	if (!is_null($priority) && $priority > -1) $obj->setPriority( Validator::sanitizeInt($priority) );
	if (!is_null($summary) && $summary != '') $obj->setSummary( Validator::sanitizeString($summary) );
	if (!is_null($details) && $details != '') $obj->setDetails( Validator::sanitizeString($details) );
	if (!is_null($sort_order) && $sort_order > -1) $obj->setSortOrder( Validator::sanitizeInt($sort_order) );
	if (!is_null($parent_id) && $parent_id > -1) $obj->setParentId( Validator::sanitizeInt($parent_id) );
	//Only in the Tasks trakers should be possible to update the open_date and close_date
	if ($obj->getTracker()->getDatatype()==Tracker::DATATYPE_TASK) {
		if (!is_null($open_date) && $open_date != '') $obj->setOpenDate( Validator::sanitizeString($open_date) );
		if (!is_null($close_date) && $close_date != '') $obj->setCloseDate( Validator::sanitizeString($close_date) );
	}
	try {
		$obj->save();
	} catch (Exception $e) {
		return new soap_fault('', 'updateTrackerItem','Permission Denied - Cannot update This Record',$e->getMessage());
	}
	return 1;
}


$server->register(
	'addTrackerItem',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_id' => 'xsd:int',
		'status_id' => 'xsd:int',
		'priority' => 'xsd:int',
		'summary' => 'xsd:string',
		'details' => 'xsd:string',
		'sort_order' => 'xsd:int',
		'parent_id' => 'xsd:int',
		'open_date' => 'xsd:string',
		'close_date' => 'xsd:string'
	), 
	array('addTrackerItem' => 'xsd:int'),
	$uri, 
	$uri.'#addTrackerItem',
	'rpc',
	'encoded'
);


/**
 * SOAP method to add a TrackerItem
 * @param	$tracker_id
 * @param	$status_id
 * @param	$priority
 * @param	$summary
 * @param	$details
 * @param	$sort_order
 * @param	$parent_id
 * @param	$open_date
 * @param	$close_date
 
 */


function addTrackerItem($sessionHash, $tracker_id, $status_id, $priority, $summary, $details, $sort_order, $parent_id, $open_date, $close_date) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$obj = new TrackerItem();
	
	if (!is_null($tracker_id) && $tracker_id > 0) $obj->setTrackerId( Validator::sanitizeInt($tracker_id) );
	if (!is_null($status_id) && $status_id > -1) $obj->setStatusId( Validator::sanitizeInt($status_id) );
	if (!is_null($priority) && $priority > -1) $obj->setPriority( Validator::sanitizeInt($priority) );
	if (!is_null($summary) && $summary != '') $obj->setSummary( Validator::sanitizeString($summary) );
	if (!is_null($details) && $details != '') $obj->setDetails( Validator::sanitizeString($details) );
	if (!is_null($sort_order) && $sort_order > -1) $obj->setSortOrder( Validator::sanitizeInt($sort_order) );
	if (!is_null($parent_id) && $parent_id > -1) $obj->setParentId( Validator::sanitizeInt($parent_id) );
	if (!is_null($open_date) && $open_date != '') $obj->setOpenDate( Validator::sanitizeString($open_date) );
	if (!is_null($close_date) && $close_date != '') $obj->setCloseDate( Validator::sanitizeString($close_date) );
	$obj->setSubmittedBy( Session::getSession()->getUser()->getUserId() );
	
	try {
		$obj->save();
		return $obj->getTrackerItemId();
	} catch (Exception $e) {
		return new soap_fault('', 'addTrackerItem','Permission Denied - Cannot add This Record',$e->getMessage());
	}
}


$server->register(
	'addTrackerItemFull',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_id' => 'xsd:int',
		'status_id' => 'xsd:int',
		'priority' => 'xsd:int',
		'summary' => 'xsd:string',
		'details' => 'xsd:string',
		'sort_order' => 'xsd:int',
		'parent_id' => 'xsd:int',
		'extra_field_data' => 'tns:ArrayOfTrackerExtraFieldData',
		'assignees' => 'tns:ArrayOfTrackerItemAssignee',
		'open_date' => 'xsd:string',
		'close_date' => 'xsd:string'
	), 
	array('addTrackerItemFull' => 'xsd:int'),
	$uri, 
	$uri.'#addTrackerItemFull',
	'rpc',
	'encoded'
);

/**
 * SOAP method to add a TrackerItem
 * @param	$tracker_id
 * @param	$status_id
 * @param	$priority
 * @param	$summary
 * @param	$details
 * @param	$sort_order
 * @param	$parent_id
 * @param	$extra_field_data
 * @param	$assignees
 */
function addTrackerItemFull($sessionHash, $tracker_id, $status_id, $priority, $summary, $details, $sort_order, $parent_id, $extra_field_data, $assignees, $open_date, $close_date) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	$Tracker = TrackerPeer::retrieveByPK($tracker_id);
	if (is_null($Tracker) || !$Tracker->userCanRead()) {
		return new soap_fault('', 'addTrackerItem','Permission Denied - Cannot add This Record', 'Permission Denied - Cannot add This Record');
	}

	$obj = new TrackerItem();
	
	$obj->setTrackerId( Validator::sanitizeInt($tracker_id) );
	$obj->setSubmittedBy( Session::getSession()->getUser()->getUserId() );
	$obj->setStatusId( Validator::sanitizeInt($status_id) );
	$obj->setPriority( Validator::sanitizeInt($priority) );
	$obj->setSummary( Validator::sanitizeString($summary) );
	$obj->setDetails( Validator::sanitizeString($details) );
	$obj->setSortOrder( Validator::sanitizeInt($sort_order) );
	$obj->setParentId( Validator::sanitizeInt($parent_id) );
	
	//Only in the Tasks trakers should be possible to update the open_date and close_date
	if (!is_null($open_date) && $open_date != '') $obj->setOpenDate( Validator::sanitizeString($open_date) );
	if (!is_null($close_date) && $close_date != '') $obj->setCloseDate( Validator::sanitizeString($close_date) );

	// Extra Fields
	$efdata = TrackerExtraFieldDatasToArray($extra_field_data, $Tracker->getTrackerExtraFields());
	$obj->addExtraFields($efdata);

	$obj->addAssignees(TrackerItemAssigneesToArray($assignees));
		
	try {
		$obj->save();
		return $obj->getTrackerItemId();
	} catch (Exception $e) {
		return new soap_fault('', 'addTrackerItem','Permission Denied - Cannot add This Record',$e->getMessage());
	}
}

function TrackerItemAssigneesToArray($assignees) {
	$valid_assignees = array();
	if (isset($assignees) && is_array($assignees) && count($assignees) > 0) {
		foreach ($assignees as $assignee) {
			$valid_assignees[$assignee['assignee']] = $assignee['percent_utilization'];
		}
	}
	return $valid_assignees;
}

function TrackerExtraFieldDatasToArray($datas, $extra_fields) {
	$extra_field_datas = array();
	$extra_field_types = array();

	foreach ($extra_fields as $extra_field) {
		$extra_field_types[$extra_field->getTrackerExtraFieldId()] = $extra_field->getFieldType();
		if ($extra_field->getFieldType() == TrackerExtraField::TYPE_TEXT ||
		    $extra_field->getFieldType() == TrackerExtraField::TYPE_TEXTAREA) {
			$extra_field_datas[$extra_field->getTrackerExtraFieldId()] = '';
		} else {
			$extra_field_datas[$extra_field->getTrackerExtraFieldId()] = '0';
		}
	}

	if (is_array($datas) && count($datas) > 0) {
		foreach ($datas as $extra_field) {
			if (isset($extra_field['tracker_extra_field_id']) && isset($extra_field['field_data'])) {
				if (isset($extra_field_types[$extra_field['tracker_extra_field_id']]) &&
					($extra_field_types[$extra_field['tracker_extra_field_id']] == TrackerExtraField::TYPE_MULTISELECT ||
					$extra_field_types[$extra_field['tracker_extra_field_id']] == TrackerExtraField::TYPE_MEMBERS ||
					$extra_field_types[$extra_field['tracker_extra_field_id']] == TrackerExtraField::TYPE_CHECKBOX)) {
					if (strpos($extra_field['field_data'], ',') !== false) {
						$extra_field_datas[$extra_field['tracker_extra_field_id']] = explode(',', $extra_field['field_data']);
					} else {
						$extra_field_datas[$extra_field['tracker_extra_field_id']] = array($extra_field['field_data']);
					}
				} else {
					$extra_field_datas[$extra_field['tracker_extra_field_id']] = $extra_field['field_data'];
				}
			}
		}
	}
	return $extra_field_datas;
}

function checkTrackerItemPermission($tracker_item_id, $type='') {
	$obj = TrackerItemPeer::retrieveByPK($tracker_item_id);
	if (is_null($obj)) {
		return false;
	} else if ($type=='delete') {
		return $obj->userCanDelete();
	} else if ($type=='create') {
		return $obj->userCanCreate();
	} else if ($type=='update') {
		return $obj->userCanUpdate();
	} else {
		return $obj->userCanRead();
	}
}

function TrackerItemToSOAP(&$obj, $full=false) {
	$ret = array();
	$ret['tracker_id'] = $obj->getTrackerId();
	$ret['tracker_item_id'] = $obj->getTrackerItemId();
	$ret['status_id'] = $obj->getStatusId();
	$ret['priority'] = $obj->getPriority();
	$ret['submitted_by'] = $obj->getSubmittedBy();
	$ret['open_date'] = $obj->getOpenDate();
	$ret['close_date'] = $obj->getCloseDate();
	$ret['summary'] = $obj->getSummary();
	$ret['details'] = $obj->getDetails();
	$ret['last_modified_date'] = $obj->getLastModifiedDate();
	$ret['last_modified_by'] = $obj->getLastModifiedBy();
	$ret['sort_order'] = $obj->getSortOrder();
	$ret['parent_id'] = $obj->getParentId();
	if ($full) {
		$ret['extra_field_data'] = array();
		foreach ($obj->getTrackerExtraFieldDatas() as $TrackerExtraFieldData) {
			$ret['extra_field_data'][] = TrackerExtraFieldDataToSOAP($TrackerExtraFieldData);
		}
		$ret['assignees'] = array();
		foreach ($obj->getTrackerItemAssignees() as $TrackerItemAssignee) {
			$ret['assignees'][] = TrackerItemAssigneeToSOAP($TrackerItemAssignee);
		}
		$ret['messages'] = array();
		foreach ($obj->getTrackerItemMessages() as $TrackerItemMessage) {
			$ret['messages'][] = TrackerItemMessageToSOAP($TrackerItemMessage);
		}
		$ret['scm_commits'] = array();
		foreach ($obj->getTrackerItemScmCommits() as $TrackerItemScmCommit) {
			$ret['scm_commits'][] = TrackerItemScmCommitToSOAP($TrackerItemScmCommit);
		}
		$ret['times'] = array();
		foreach ($obj->getTrackerItemTimes() as $TrackerItemTime) {
			$ret['times'][] = TrackerItemTimeToSOAP($TrackerItemTime);
		}
		$ret['duplicates'] = array();
		foreach ($obj->getTrackerItemDuplicatesRelatedByTrackerItemId() as $TrackerItemDuplicates) {
			$ret['duplicates'][] = TrackerItemDuplicateToSOAP($TrackerItemDuplicates);
		}
		$ret['relations'] = array();
		foreach ($obj->getTrackerItemRelationsRelatedByTrackerItemId() as $TrackerItemRelation) {
			$ret['relations'][] = TrackerItemRelationToSOAP($TrackerItemRelation);
		}
	}
	return $ret;
}


function TrackerItemShortToSOAP(&$obj) {
	$ret = array();
	$ret['tracker_id'] = $obj->getTrackerId();
	$ret['tracker_item_id'] = $obj->getTrackerItemId();
	$ret['status_id'] = $obj->getStatusId();
	$ret['priority'] = $obj->getPriority();
	$ret['submitted_by'] = $obj->getSubmittedBy();
	$ret['open_date'] = $obj->getOpenDate();	
	$ret['close_date'] = $obj->getCloseDate();
	$ret['summary'] = $obj->getSummary();
	$ret['assignees'] = array();
	foreach ($obj->getTrackerItemAssignees() as $TrackerItemAssignee) {
		$ret['assignees'][] = TrackerItemAssigneeToSOAP($TrackerItemAssignee);
	}

	return $ret;
}



$server->register(
	'getTrackerItemsShort',
	array(
		'sessionHash'	=> 'xsd:string',
		'tracker_id' => 'xsd:int',
		'status_id' => 'xsd:int',
		'query_id' => 'xsd:int',
		'limit' => 'xsd:int',
		'offset' => 'xsd:int'
		), 
	array('getTrackerItemsShort' => 'tns:ArrayOfTrackerItemShort'),
	$uri, 
	$uri.'#getTrackerItemsShort',
	'rpc',
	'encoded'
);


/**
 * SOAP method to retrieve a list of TrackerItem
 * @param	$tracker_id	Filter by tracker_id 
 * @param	$status_id	Filter by status_id
 */
function getTrackerItemsShort($sessionHash, $tracker_id, $status_id, $query_id, $limit=200, $offset=0) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);

	if ($query_id>0) {
		$obj = TrackerQueryPeer::retrieveByPK($query_id);
		if (is_null($obj) || !checkQueryPermission($obj)) {
			return new soap_fault('', 'getTrackerItemsShort','Permission Denied - Cannot View These Records','Permission Denied - Cannot View This Record');
		}
		$Tracker = TrackerPeer::retrieveByPK($obj->getTrackerId());
		if (is_null($Tracker) || !$Tracker->userCanRead()) {
			return new soap_fault('', 'getTrackerItemsort','Permission Denied - Cannot View These Records','Permission Denied - Cannot View This Record');
		}
		$tq = new TrackerItemSavedQuery($Tracker, $obj);

		$ret = array();
		$objs = $tq->getTrackerItems($limit, $offset);
		foreach ($objs as $obj) {
			if ($obj->userCanRead()) {
				$ret[] = TrackerItemShortToSOAP($obj);
			}
		}
		return $ret;
	}
	else {
		$c = new Criteria();

		if ($tracker_id > 0) {
			$c->add(TrackerItemPeer::TRACKER_ID, $tracker_id);
		}

		if ($status_id > 0) {
			$c->add(TrackerItemPeer::STATUS_ID, $status_id);
		}
		
		$c->setLimit($limit);
		$c->setOffset($offset);
		
		$objs = TrackerItemPeer::doSelect($c);
		$res = array();
		foreach ($objs as $obj) {
			if ($obj->userCanRead()) {
				$res[] = TrackerItemShortToSOAP($obj);
			}
		}
	}
	return $res;
	
}

?>