<?php

/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Prez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/User.php');
require_once('Validator.php');

$user_ids = $_POST['users'];
$user_ids = explode(',', $user_ids);

if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

$feedback = '';
foreach ($user_ids as $user_id) {
	$user_id = Validator::sanitizeInt($user_id);
	if (!is_numeric($user_id)) {
		continue;
	}
	
	$user = UserPeer::retrieveByPk($user_id);
	if (!is_object($user)) {
		continue;
	}

	$user_name = $user->getFullName();
	$feedback .= Language::getSessText('SiteAdmin.UserApprove.Approving',array($user_name)) . '<br />';
	if ($user->approve()) {
		$feedback .= Language::getSessText('SiteAdmin.UserApprove.Approved',array($user_name)) . '<br />';
	} else {
		$feedback .= Language::getSessText('SiteAdmin.UserApprove.NotApproved',array($user_name)) . '<br />';
	}
}

GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('PendingUserApproval',array('feedback'=>$feedback)));

?>
