<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Usergroup
//
require_once('core/UserPeer.php');
require_once('core/User.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

$params = array(
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Usergroup.BrowsePageTitle')
		);
$theme->header($params);

$columns = array(
	UserPeer::UNIX_NAME  => $Lang->getText('Usergroup.UsergroupIdName'),
	UserPeer::FIRSTNAME => $Lang->getText('Usergroup.MemberUserIdName'),
	$Lang->getText('Edit'),
	$Lang->getText('Delete')
);

// Retrieve the objects array
$crit = new Criteria();
$crit->add(UserPeer::IS_GROUP,true);
$total = UserPeer::doCount($crit);
$paginator = new Paginator('grpadmin', -1, $total, UserPeer::USER_ID, $columns);
$paginator->addPageClauses($crit);
$arr = UserPeer::doSelect($crit);



$theader = $paginator->getSortableTableHeaders($theme);

//echo $paginator->showLimitOptions();

/*$theader = array();

$theader[] = $Lang->getText('Usergroup.UsergroupIdName');
$theader[] = $Lang->getText('Usergroup.MemberUserIdName');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');*/

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('Usergroup.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]=$item->getUnixName();
		$trow[]=$item->getFullName();
		if ($item->getStatus() == User::STATUS_DELETED) {
			$trow[]='&nbsp;';
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupUndelete').'&amp;id='.$item->getUserID() .'">'. $Lang->getText('Usergroup.Undelete') .'</a>';
		} else {
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupEdit').'&amp;id='.$item->getUserID() .'">'. $Lang->getText('Edit') .'</a>';
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupDelete').'&amp;id='.$item->getUserID() .'">'. $Lang->getText('Delete') .'</a>';
		}
		echo $theme->tableRow($trow, array(), false);
	}
}

//echo $theme->listPaginatorRow($paginator);
//echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupAdd').'">'. $Lang->getText('Usergroup.AddNew') .'</a>'));
$button_array = array();
$button_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('UsergroupAdd').'">'. $Lang->getText('Usergroup.AddNew') .'</a>';
$button_array[] = '<a href="'. GFUrl::getUrl()->currentBaseUrl('').'">'. $Lang->getText('Common.Back') .'</a>';
echo $theme->tableBottom($button_array,array(true, true));

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}


$theme->footer($params);

?>
