<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/templates/SiteAdminTemplate.php');
require_once('lib/core/ProjectPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/UserPeer.php');

$template = new SiteAdminTemplate();
$params = array(
		'title'	=> 'User/Group Search'
	);
$template->header($params);

$con = Propel::getConnection(UserPeer::DATABASE_NAME);


if (array_key_exists('search',$_REQUEST)) {
	$search = $_REQUEST['search'];
} else {
	$search = null;
}
if (array_key_exists('substr',$_REQUEST)) {
	$substr = $_REQUEST['substr'];
} else {
	$substr = null;
}
if (array_key_exists('usersearch',$_REQUEST)) {
	$usersearch = $_REQUEST['usersearch'];
} else {
	$usersearch = null;
}
if (array_key_exists('projectsearch',$_REQUEST)) {
	$projectsearch = $_REQUEST['projectsearch'];
} else {
	$projectsearch = null;
}

if ($substr) {
	$search = "%$search%";
}


if ($usersearch) {
	require_once('forms/UserSearch-tpl.php');
	$search = htmlentities($search,ENT_QUOTES);
	
	$columns = array(
		UserPeer::USER_ID  => Language::getSessText('SiteAdmin.Search.Id'),
		UserPeer::UNIX_NAME => Language::getSessText('SiteAdmin.Search.UserName'),
		UserPeer::FIRSTNAME.'||'.UserPeer::LASTNAME => Language::getSessText('SiteAdmin.Search.Name'),
		UserPeer::EMAIL => Language::getSessText('SiteAdmin.Search.Email'),
		UserPeer::CREATE_DATE => Language::getSessText('SiteAdmin.Search.MemberSince'),
		UserPeer::STATUS => Language::getSessText('SiteAdmin.Search.Status'),
		Language::getSessText('Edit'),
		Language::getSessText('SiteAdmin.UserList.Activate'),
		Language::getSessText('SiteAdmin.UserList.Delete')
		);
	
	$sql = '
	    SELECT DISTINCT COUNT(*)
	    FROM "user"
	    WHERE is_group=false
		AND (user_id ILIKE ?
	    OR unix_name ILIKE ?
	    OR email ILIKE ?
	    OR firstname ILIKE ?)'; 
	
	$stmt = $con->prepareStatement($sql);
	$stmt->setInt(1, $search);
	$stmt->setString(2, "%$search%");
	$stmt->setString(3, "%$search%");
	$stmt->setString(4, "%$search%");

	$rs = $stmt->executeQuery(ResultSet::FETCHMODE_NUM);
	$rs->next();
	$total = $rs->getInt(1);
	$paginator = new Paginator('usradmsearch', -1, $total, UserPeer::USER_ID, $columns);
	
	
	$sql = '
	    SELECT DISTINCT *
	    FROM "user"
	    WHERE is_group=false
		AND (user_id ILIKE ?
	    OR unix_name ILIKE ?
	    OR email ILIKE ?
	    OR firstname ILIKE ?) ' . $paginator->getSQL(); 
	
	$stmt = $con->prepareStatement($sql);
	$stmt->setInt(1, $search);
	$stmt->setString(2, "%$search%");
	$stmt->setString(3, "%$search%");
	$stmt->setString(4, "%$search%");

	$rs = $stmt->executeQuery(ResultSet::FETCHMODE_ASSOC);
	print '<p><strong>' .Language::getSessText('SiteAdmin.Search.UserSearch').' "<em>'.$search.'</em>": '
	      .$rs->getRecordCount() .' '. Language::getSessText('SiteAdmin.Search.Matches').'</strong></p>';

	if ($rs->getRecordCount() < 1) {
		//TODO display error
		echo "No Matches";
	} else {

		// Hack to make GFURL::currentURL pass the search fields that came in the $_POST variable.
		$oldget = $_GET;
		$_GET = $_REQUEST;					 
		echo $template->tableTop($paginator->getSortableTableHeaders($template));
		$_GET = $oldget;

		while ($rs->next()) {
			$user_id = $rs->getInt('user_id');
			$status = $rs->getInt('status');
			$unix_name = $rs->getString('unix_name');
			$user_name = $rs->getString('firstname') . ' ' . $rs->getString('lastname');
			$email = $rs->getString('email');
			$create_date = $rs->getDate('create_date');
			$i = 0;
			$trow = array();
			$trow[] = '<a href="'. GFUrl::getUrl()->currentBaseURL('UserEdit',array('user_id'=>$user_id)) .'">'.$user_id.'</a>';
			$trow[] = $unix_name;
			$trow[] = '<a href="/gf/user/'.$unix_name.'/">'.$user_name.'</a>';
			$trow[] = $email;
			$trow[] = date($create_date);
			if ($status == User::STATUS_ACTIVE) {
				$trow[]=Language::getSessText('SiteAdmin.UserList.Active');
			} elseif ($status == User::STATUS_DELETED ) {
				$trow[]=Language::getSessText('SiteAdmin.UserList.Deleted');
			} elseif ($status == User::STATUS_SUSPENDED) {
				$trow[]=Language::getSessText('SiteAdmin.UserList.Suspended');
			} elseif ($status == User::STATUS_PENDING ) {
				$trow[]=Language::getSessText('SiteAdmin.UserEdit.Pending');
			} elseif ($status == User::STATUS_PENDING_APPROVAL ) {
				$trow[]=Language::getSessText('SiteAdmin.UserList.PendingApproval');
			}
			$trow[] = '<a href="'. GFUrl::getUrl()->currentBaseURL('UserEdit',array('user_id'=>$user_id)) .'">'.Language::getSessText('Edit').'</a>';
			if ($status == User::STATUS_ACTIVE) {
				$trow[]='&nbsp;';
			} else {
				$trow[]='<a href="'. GFUrl::getUrl()->currentBaseURL('UserEditAction',array('_action'=>'activate','user_id'=>$user_id,'return_to'=>'UserBrowse')) . '">' .Language::getSessText('SiteAdmin.UserList.Activate'). '</a>';
			}
			if ($status == User::STATUS_DELETED ) {
				$trow[]='&nbsp;';
			} else {
				$trow[]='<a href="'. GFUrl::getUrl()->currentBaseURL('UserDelete',array('user_id'=>$user_id)) . '">' .Language::getSessText('SiteAdmin.UserList.Delete') .'</a>';
			}
			echo $template->tableRow($trow);
		}

		echo $template->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('').'">'. Language::getSessText('Common.Back') .'</a>'));
		if(isset($paginator) && is_object($paginator)) {
			echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
		}
	} 
	
} 


if ($projectsearch) {
	require_once('forms/ProjectSearch-tpl.php');
	if (array_key_exists('status',$_REQUEST)) {
		$status = $_REQUEST['status'];
	} else {
		$status = null;
	}
	if (array_key_exists('is_public',$_REQUEST)) {
		$is_public = $_REQUEST['is_public'];
	} else {
		$is_public = null;
	}
	if (array_key_exists('crit_desc',$_REQUEST)) {
		$crit_desc = $_REQUEST['crit_desc'];
	} else {
		$crit_desc = null;
	}		
	$crit_sql = '';
	if ($status!=null) {
		$crit_sql  = " AND status='$status'";
		$crit_desc .= " status=$status";
	}
	if ($is_public!=null) {
		$crit_sql  .= " AND is_public='$is_public'";
		$crit_desc .= " is_public=$is_public";
	}
	
	$search = htmlentities($search,ENT_QUOTES);
	$columns = array(
		ProjectPeer::PROJECT_ID => Language::getSessText('SiteAdmin.Search.Id'),
		ProjectPeer::UNIX_NAME => Language::getSessText('Project.UnixNameName'),
		ProjectPeer::PROJECT_NAME => Language::getSessText('Project.ProjectNameTitle'),
		ProjectPeer::CREATE_DATE => Language::getSessText('Project.Registered'),
		ProjectPeer::STATUS => Language::getSessText('SiteAdmin.Search.Status'),
		ProjectPeer::IS_TEMPLATE => Language::getSessText('Project.IsTemplate'),
		Language::getSessText('Edit'),
		Language::getSessText('Delete')
		);
	
	$sql = '
		SELECT DISTINCT COUNT(*)
		FROM project
		WHERE (project_id ILIKE ?
		OR unix_name ILIKE ?
		OR project_name ILIKE ?)' . $crit_sql ; 
	
	$stmt = $con->prepareStatement($sql);
	$stmt->setInt(1, $search);
	$stmt->setString(2, "%$search%");
	$stmt->setString(3, "%$search%");
	$rs = $stmt->executeQuery(ResultSet::FETCHMODE_NUM);
	$rs->next();
	$total = $rs->getInt(1);
	
	$paginator = new Paginator('prjadmsearch', -1, $total, ProjectPeer::PROJECT_ID, $columns);
	
	$sql = '
		SELECT DISTINCT *
		FROM project
		WHERE (project_id ILIKE ?
		OR unix_name ILIKE ?
		OR project_name ILIKE ?)' . $crit_sql . ' ' . $paginator->getSQL(); 
	
	$stmt = $con->prepareStatement($sql);
	$stmt->setInt(1, $search);
	$stmt->setString(2, "%$search%");
	$stmt->setString(3, "%$search%");
	$rs = $stmt->executeQuery(ResultSet::FETCHMODE_ASSOC);
	
	if ($crit_desc) {
		$crit_desc = "($crit_desc )";
	}
	print '<p><strong>' .Language::getSessText('SiteAdmin.Search.ProjectSearch').'"<em>'.$search.'</em>" '.$crit_desc.': '
	      .$rs->getRecordCount().' '.Language::getSessText('SiteAdmin.Search.Matches').'</strong></p>';

	if ($rs->getRecordCount() < 1) {
		echo Language::getSessText('Options.None');
	} else {
		
		// Hack to make GFURL::currentURL pass the search fields that came in the $_POST variable.
		$oldget = $_GET;
		$_GET = $_REQUEST;					 
		echo $template->tableTop($paginator->getSortableTableHeaders($template));
		$_GET = $oldget;
		
		$i=0;
		while ($rs->next()) {

			$extra_status = "";
			if (!$rs->getBoolean('is_public')) {
				$extra_status = "/PRV";
			}
			$project_id = $rs->getInt('project_id');
			$unix_name = $rs->getString('unix_name');
			switch ($rs->getInt('status')) {
				case Project::STATUS_ACTIVE : $status = Language::getSessText('SiteAdmin.UserEdit.Active');break;
				case Project::STATUS_PENDING : $status = Language::getSessText('SiteAdmin.UserEdit.Pending');break;
				case Project::STATUS_HOLDING : $status = Language::getSessText('SiteAdmin.ProjectEdit.Holding');break;
			}	

			$trow = array();
			$trow[] = '<a href="'. GFUrl::getUrl()->currentBaseURL('ProjectEdit',array('id'=>$project_id)).'">'.$project_id.'</a>';
			$trow[] = $unix_name;
			$trow[] = '<a href="/gf/project/'.$unix_name.'/">'.$rs->getString('project_name').'</a>';
			$trow[] = date($rs->getDate('create_date'));
			$trow[] = $status;
			if ($rs->getBoolean('is_template')) {
				$trow[] = Language::getSessText('Common.Yes'); //express doesn't have templates .' - '.'<a href="'.GFUrl::getUrl()->currentBaseURL('ExportTplAction').'&amp;id='.$rs->getInt('project_id') .'">'.Language::getSessText('ProjectTemplate.LegacyExportText').'</a>';
				$deletelink = '';
			} else {
				$trow[] = '';
				$deletelink = '<a href="'. GFUrl::getUrl()->currentBaseUrl('ProjectDelete').'&amp;id='.$rs->getInt('project_id') .'">'. Language::getSessText('Delete') .'</a>';
			}
			if ($rs->getInt('status')==Project::STATUS_PENDING) {
				$trow[]='&nbsp;';
			} else {
				$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('ProjectEdit').'&amp;id='.$rs->getInt('project_id') .'">'. Language::getSessText('Edit') .'</a>';
			}
			$trow[]=$deletelink;

			echo $template->tableRow($trow);			
		}
		
		echo $template->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('').'">'. Language::getSessText('Common.Back') .'</a>'));
		
		if(isset($paginator) && is_object($paginator)) {
			echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
		}
	} 
	
}


$template->footer();
?>
