<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('core/ProjectPeer.php');
require_once('session/Session.php');
require_once('core/Plugin.php');
require_once('plugin/GFPlugin.php');
require_once('core/RolePeer.php');
require_once('core/UserProject.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$project = GFUrl::getUrl()->getProject();
$project_id = $project->getProjectId();
$Lang = $session->getLanguage();


require_once('html/templates/ProjectAdminTemplate.php');
$template = new ProjectAdminTemplate();
$params = array(
		'selectedbottomtab'	=> 'project_admin',
		'project' => $project,
		'title' => Language::getSessText('ProjectAdmin.title'),
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : ''
	);
$template->header($params);

?>


<table width="100%" cellpadding="2" cellspacing="2" border="0">
	<tr valign="top">
		<td width="50%">
			<?php echo $template->infoTableTop(Language::getSessText('ProjectAdmin.PluginAdmin')); ?>
			<?php require_once('forms/PluginAdmin-tpl.php'); 
			echo $template->infoTableBottom();
			?>
		</td>
		<td>&nbsp;</td>
		<td>
			<?php
			echo $template->infoTableTop(Language::getSessText('ProjectAdmin.AdminOptions'));
			echo '<ul>';
			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('UserRole').'">'.Language::getSessText('ProjectAdmin.UserRole').'</a>';
			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('ObserverEdit').'">'.Language::getSessText('Project.EditObserver').'</a>';
			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('RoleBrowse').'">'.Language::getSessText('Project.RoleBrowse').'</a>';
			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('EditDescription').'">'.Language::getSessText('Project.EditDesc').'</a>';
			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('EditHomepage').'">'.Language::getSessText('Project.EditHomepage').'</a>';
			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('ProjectEdit').'">'.Language::getSessText('Project.EditInfo').'</a>';

			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('ProjectJoinRequestBrowse').'">'.Language::getSessText('ProjectJoinRequest.BrowsePageTitle').'</a>';

//			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('ParentProject').'">'.Language::getSessText('ProjectAdmin.ParentProjectLink').'</a>';
			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('TroveEdit').'">'.Language::getSessText('ProjectAdmin.TroveCategorization').'</a>';
//			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('ExportRequest').'">'.Language::getSessText('ProjectTemplate.ExportFullPageName').'</a>';
			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('AuditTrail').'">'.Language::getSessText('ProjectReporting.AuditTrail').'</a>';
			echo '<li><a href="'.GFUrl::getUrl()->currentBaseURL('PluginSettings').'">'.Language::getSessText('ProjectAdmin.PluginSettings').'</a>';
			echo '</ul>';
			
			echo $template->infoTableBottom(); ?>
		</td>
	</tr>

</table>
		
<?php
$template->footer();
?>
